/****************************************************
JavaRa (javara.cpp) (c) Paul "Prm753" McLain and Fred de Vries, 2008, 2009.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
************************************************************/

#include <windows.h>
#include <stdio.h>
#include <shlwapi.h>
#include "javara.h"
#include <time.h>
#include <tlhelp32.h>
#include <winreg.h>
#include "hyperlinks.cpp"
#include "hyperlinks.h"
#include "killprocess.cpp"
#include <tchar.h>
#include <process.h>

#define BUFFER_SIZE 256

#define GLOBAL_LANGUAGE_ENGLISH 0
#define GLOBAL_LANGUAGE_DUTCH   1
#define GLOBAL_LANGUAGE_SPANISH 2
#define GLOBAL_LANGUAGE_ITALIAN 3
#define GLOBAL_LANGUAGE_SWEDISH 4
#define GLOBAL_LANGUAGE_FRENCH  5
#define GLOBAL_LANGUAGE_FINNISH 6
#define GLOBAL_LANGUAGE_POLISH  7
#define GLOBAL_LANGUAGE_GERMAN  8
#define GLOBAL_LANGUAGE_RUSSIAN 9

#define SYSTEM_VERSION_VISTA 500
#define SYSTEM_VERSION_XP    501
#define SYSTEM_VERSION_OTHER 502

#define STR_HIGHER           600
#define STR_LOWER            601
#define STR_EQUAL            602

int globalLanguageChosen; 
// bool globalLogShow = true; 

char * langList[] = { "English", "Nederlands", "Espaol", "Italiano", "Svenska", "Franais", "Suomi", "Polski", "Deutsch" } ;

char szText[BUFFER_SIZE];
HINSTANCE hInst;
HBITMAP g_hbmBall = NULL;

int GetSystemVersion()
{
    OSVERSIONINFOEX osvi;
    SYSTEM_INFO si;
    BOOL bOsVersionInfoEx;

    ZeroMemory(&si, sizeof(SYSTEM_INFO));
    ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));

    // Try calling GetVersionEx using the OSVERSIONINFOEX structure.
    // If that fails, try using the OSVERSIONINFO structure.

    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);

    if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
    {
        osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
        if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
           return FALSE;
    }

    else GetSystemInfo(&si);

   switch (osvi.dwPlatformId)
   {
      // Test for the Windows NT product family.

      case VER_PLATFORM_WIN32_NT:

      // Test for the specific product.

      if ( osvi.dwMajorVersion == 6 && osvi.dwMinorVersion == 0 )
      {
         if( osvi.wProductType == VER_NT_WORKSTATION )
         {
            // determined that Vista was found
            return SYSTEM_VERSION_VISTA;     
         }
      }
      
      if ( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1 ) 
      {
         // determined that XP was found
         return SYSTEM_VERSION_XP; 
      }
      
      else if ( osvi.dwMajorVersion != 5 &&  osvi.dwMinorVersion != 1 && osvi.dwMajorVersion != 6 && osvi.dwMinorVersion != 0 )
      { 
           return SYSTEM_VERSION_OTHER; 
      }  
      
      break;
  }
}
   

int DeleteAny(char *envVar, char *cFileName)
{
    int fileOperationCheck;
    char logname[100];
    GetEnvironmentVariable("HOMEDRIVE", logname, 100);
    strcat(logname, "\\JavaRa.log");
                       
    FILE *fp;
    fp = fopen(logname, "a");
    
    char varOutput[MAX_PATH]; 
    ZeroMemory(varOutput, MAX_PATH); 
    
    GetEnvironmentVariable(envVar, varOutput, sizeof(varOutput)); 
    
    char temp[255];
    memset( temp, 0, sizeof(temp) );
    SHFILEOPSTRUCT folderFunction;
    memset( &folderFunction, 0, sizeof(folderFunction) );
    lstrcpy(temp, varOutput);
    lstrcat(temp, cFileName);
    lstrcat(temp, "\0");
    
    folderFunction.hwnd = NULL;
    folderFunction.wFunc = FO_DELETE;
    folderFunction.pFrom = temp; 
    folderFunction.pTo = NULL;
    folderFunction.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI;
    fileOperationCheck = SHFileOperation(&folderFunction);
    
    switch(fileOperationCheck)
    {
        case 0:
             fprintf(fp, "Found and removed: %s\r\n", temp);
        break;
        
        case ERROR_ACCESS_DENIED:
             MoveFileEx(temp, NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
             fprintf(fp, "Could not delete: %s\r\nAsking Windows to delete %s on reboot.", temp);
        break;
        
        case ERROR_FILE_NOT_FOUND:
             // need to catch this case, but don't need to log it
             //      fprintf(fp, "Did not find: %s\r\n", temp);
        break;
        
        case 1026:
             // need to catch this case, but don't need to log it
             //      fprintf(fp, "Did not find: %s\r\n", tempFolderPath);
        break;
        
        default:
             fprintf(fp, "There was an error removing %s. The error returned was %i.\r\n", temp, fileOperationCheck);
        break;
    }
    fclose(fp);
}

int RemoveFolders(char *javaPathRemember, char *cFileName)
{
    int fileOperationCheck;
    char logname[100];
    GetEnvironmentVariable("HOMEDRIVE", logname, 100);
    strcat(logname, "\\JavaRa.log");
                       
    FILE *fp;
    fp = fopen(logname, "a");
    
    char temp[255];
    memset( temp, 0, sizeof(temp) );
    SHFILEOPSTRUCT folderFunction;
    memset( &folderFunction, 0, sizeof(folderFunction) );
    lstrcpy(temp, javaPathRemember);
    lstrcat(temp, cFileName);
    lstrcat(temp, "\0");
    
    folderFunction.hwnd = NULL;
    folderFunction.wFunc = FO_DELETE;
    folderFunction.pFrom = temp; 
    folderFunction.pTo = NULL;
    folderFunction.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI;
    fileOperationCheck = SHFileOperation(&folderFunction);
    
    switch(fileOperationCheck)
    {
        case 0:
             fprintf(fp, "Found and removed: %s\r\n", temp);
        break;
        
        case ERROR_ACCESS_DENIED:
             fprintf(fp, "Could not delete: %s\r\nAsking Windows to delete %s on reboot.", temp);
             MoveFileEx(temp, NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
        break;
        
        case ERROR_FILE_NOT_FOUND:
        //      fprintf(fp, "Did not find: %s\r\n", tempFolderPath);
        break;
        
        case 1026:
        //      fprintf(fp, "Did not find: %s\r\n", tempFolderPath);
        break;
        
        default:
             fprintf(fp, "There was an error removing %s. The error returned was %i.\r\n", temp, fileOperationCheck);
        break;
    }
    fclose(fp);
}

int RemoveRegKeys(HKEY regAddressOne, char *regAddressTwo, bool silent)
{
    int doesExist; 
    char buffer[255];
    char output[255];
    
    ZeroMemory(buffer, 255);
    ZeroMemory(output, 255); 
    
    char logname[100];
                       
    GetEnvironmentVariable("HOMEDRIVE", logname, 100);
    strcat(logname, "\\JavaRa.log");
                       
    FILE *fp;
    fp = fopen(logname, "a");
    
    HKEY hkey;
    int check = RegOpenKeyEx(regAddressOne, regAddressTwo, 0, KEY_SET_VALUE, &hkey);
    doesExist = SHDeleteKey(regAddressOne, regAddressTwo);
    RegCloseKey(hkey);
    
    if (doesExist == 0)
    {
       TCHAR szOne[MAX_PATH];
       ZeroMemory(szOne, MAX_PATH); 
       
       switch(globalLanguageChosen)
       {
            case GLOBAL_LANGUAGE_ENGLISH:
                 lstrcpy(szOne, "Found and removed:");
            break;
            case GLOBAL_LANGUAGE_SPANISH:
                 lstrcpy(szOne, "Encontrados y eliminado:"); 
            break;
            case GLOBAL_LANGUAGE_DUTCH:
                 lstrcpy(szOne, "Gevonden en verwijderd:");
            break;
            case GLOBAL_LANGUAGE_ITALIAN:
                 lstrcpy(szOne, "Trovato e rimosso:");
            break; 
            case GLOBAL_LANGUAGE_SWEDISH:
                 lstrcpy(szOne, "Funnet och borttaget:");
            break; 
            case GLOBAL_LANGUAGE_FRENCH:
                 lstrcpy(szOne, "Enleve trouv:"); 
            break;
            case GLOBAL_LANGUAGE_FINNISH:
                 lstrcpy(szOne, "Lydetty ja poistettu:"); 
            break; 
            case GLOBAL_LANGUAGE_POLISH:
                 lstrcpy(szOne, "Znaleziono i usunie;to:"); 
            break; 
            case GLOBAL_LANGUAGE_GERMAN:
                 lstrcpy(szOne, "Gefunden und gelscht:"); 
            break; 
            default:
                 lstrcpy(szOne, "Found and removed:"); 
            break;
       }
       
       fprintf(fp, "Found and removed: %s\r\n", regAddressTwo);
       sprintf(buffer, "%s %s\r\n", szOne, regAddressTwo);
       lstrcpy(output, buffer);
       
       if (silent != true)
       {
           MessageBox(0, output, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION); 
       }
    
    }
    fclose(fp); 
}

int RemoveRegValues(HKEY regAddressOne, char *regAddressTwo, char *regAddressThree, bool silent)
{
    int doesExist;
    
    char buffer[255];
    char output[255];
    
    ZeroMemory(buffer, 255);
    ZeroMemory(output, 255); 
    
    char logname[100];
    GetEnvironmentVariable("HOMEDRIVE", logname, 100);
    strcat(logname, "\\JavaRa.log");
                       
    FILE *fp;
    fp = fopen(logname, "a");   
    
    HKEY hkey;
    RegOpenKeyEx(regAddressOne, regAddressTwo, 0, KEY_SET_VALUE, &hkey);
    doesExist = RegDeleteValue(hkey, regAddressThree);
    RegCloseKey(hkey);
    
    if (doesExist == 0)
    {
       TCHAR szOne[MAX_PATH];
       ZeroMemory(szOne, MAX_PATH); 
       
       switch(globalLanguageChosen)
       {
            case GLOBAL_LANGUAGE_ENGLISH:
                 lstrcpy(szOne, "Found and removed:");
            break;
            case GLOBAL_LANGUAGE_SPANISH:
                 lstrcpy(szOne, "Encontrados y eliminado:"); 
            break;
            case GLOBAL_LANGUAGE_DUTCH:
                 lstrcpy(szOne, "Gevonden en verwijderd:");
            break;
            case GLOBAL_LANGUAGE_ITALIAN:
                 lstrcpy(szOne, "Trovato e rimosso:");
            break; 
            case GLOBAL_LANGUAGE_SWEDISH:
                 lstrcpy(szOne, "Funnet och borttaget:");
            break; 
            case GLOBAL_LANGUAGE_FRENCH:
                 lstrcpy(szOne, "Enleve trouv:"); 
            break;
            case GLOBAL_LANGUAGE_FINNISH:
                 lstrcpy(szOne, "Lydetty ja poistettu:"); 
            break; 
            case GLOBAL_LANGUAGE_POLISH:
                 lstrcpy(szOne, "Znaleziono i usunie;to:"); 
            break;
            case GLOBAL_LANGUAGE_GERMAN: 
                 lstrcpy(szOne, "Gefunden und gelscht:"); 
            break; 
            default:
                 lstrcpy(szOne, "Found and removed:"); 
            break;
       }
       
       fprintf(fp, "Found and removed: %s\\%s\r\n", regAddressTwo, regAddressThree);
       sprintf(buffer, "%s %s\\%s", szOne, regAddressTwo, regAddressThree);
       lstrcpy(output, buffer);
       
       if (silent != true)
       {
                  MessageBox(0, output, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION); 
       }
    }
    fclose(fp); 
}

int DeleteTempFilesJava(char *environmentVariable, char *searchFlags)
{
    char toBeDeleted[MAX_PATH];
    char searchPath[MAX_PATH];
    char searchPathTwo[MAX_PATH]; 
    char ourPath[MAX_PATH]; 
                          
    ZeroMemory(toBeDeleted, MAX_PATH); 
    ZeroMemory(searchPath, MAX_PATH); 
    ZeroMemory(searchPathTwo, MAX_PATH);
    ZeroMemory(ourPath, MAX_PATH);  

    lstrcpy(searchPath, environmentVariable);
    lstrcat(searchPath, "\\");
    lstrcat(searchPath, searchFlags);
    
    WIN32_FIND_DATA FindFileData;
    HANDLE hHandle = FindFirstFile(searchPath, &FindFileData);
    
    lstrcpy(toBeDeleted, environmentVariable);
    lstrcat(toBeDeleted, "\\");
    lstrcat(toBeDeleted, FindFileData.cFileName);
    
    DeleteFile(toBeDeleted);
    ZeroMemory(toBeDeleted, MAX_PATH);
    
    while ( FindNextFile(hHandle, &FindFileData) != 0 )
    {     
          lstrcpy(toBeDeleted, environmentVariable);
          lstrcat(toBeDeleted, "\\");
          lstrcat(toBeDeleted, FindFileData.cFileName);
    
          DeleteFile(toBeDeleted);
          ZeroMemory(toBeDeleted, MAX_PATH);
    }
    
    
}

int DeleteUselessJavaFiles(char *javaPathRemember, char *javaEnvironmentVariable, char *flags)
{
    char toBeDeleted[MAX_PATH];
    char searchPath[MAX_PATH];
    char searchPathTwo[MAX_PATH]; 
    char ourPath[MAX_PATH]; 
                          
    ZeroMemory(toBeDeleted, MAX_PATH); 
    ZeroMemory(searchPath, MAX_PATH); 
    ZeroMemory(searchPathTwo, MAX_PATH);
    ZeroMemory(ourPath, MAX_PATH);  
                          
    lstrcpy(toBeDeleted, javaPathRemember);
    lstrcpy(searchPathTwo, toBeDeleted); 
    lstrcat(searchPath, javaEnvironmentVariable); 
                          
    DWORD dwError;
    WIN32_FIND_DATA FindFileData;
    HANDLE hHandle = FindFirstFile(searchPath, &FindFileData); 
    
    lstrcat(searchPathTwo, FindFileData.cFileName); 
    lstrcpy(ourPath, FindFileData.cFileName); 
    lstrcat(toBeDeleted, FindFileData.cFileName); 
    lstrcat(toBeDeleted, "\\");
    ZeroMemory(FindFileData.cFileName, sizeof(FindFileData.cFileName)); 
                          
    lstrcat(searchPathTwo, flags);
    hHandle = FindFirstFile(searchPathTwo, &FindFileData); 
    lstrcat(toBeDeleted, FindFileData.cFileName);
    DeleteFile(toBeDeleted);
    ZeroMemory(toBeDeleted, MAX_PATH); 
                          
    while ( FindNextFile(hHandle, &FindFileData) != 0 )
    {
          lstrcpy(toBeDeleted, javaPathRemember);
          lstrcat(toBeDeleted, ourPath); 
          lstrcat(toBeDeleted, "\\");
          lstrcat(toBeDeleted, FindFileData.cFileName); 
          DeleteFile(toBeDeleted); 
    }
                     
    FindClose(hHandle); 
}

BOOL CALLBACK AboutDlgProc( HWND hDlgWnd, UINT message,
                            WPARAM wParam, LPARAM lParam)
{ 
      switch (message)
      {
             case WM_INITDIALOG:
             {
                  ConvertStaticToHyperlink(hDlgWnd, IDB_HYLNK);     
                  ConvertStaticToHyperlink(hDlgWnd, IDB_HYLNKTWO); 
                  
                  char szOne[MAX_PATH * 4];
                  char szTwo[MAX_PATH];
                  char szThree[MAX_PATH];
                  
                  char globalSz[MAX_PATH * 4]; 
                  
                  switch(globalLanguageChosen)
                  {
                      case GLOBAL_LANGUAGE_DUTCH:
                      
                           LoadString(hInst, DUT_Q24, szOne, sizeof(szOne)); 
                           LoadString(hInst, DUT_Q25, szTwo, sizeof(szTwo)); 
                           LoadString(hInst, DUT_Q26, szThree, sizeof(szThree)); 
                           
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNKTWO), szThree); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), szOne); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNK), szTwo); 
                           
                      
                      break; 
                      
                      case GLOBAL_LANGUAGE_SPANISH:
                           LoadString(hInst, ESP_Q24, szOne, MAX_PATH * 4); 
                           LoadString(hInst, ESP_Q25, szTwo, sizeof(szTwo)); 
                           LoadString(hInst, ESP_Q26, szThree, sizeof(szThree)); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNK), szTwo); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNKTWO), szThree); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), szOne); 
                      break; 
                      
                      case GLOBAL_LANGUAGE_ITALIAN:
                           LoadString(hInst, ITA_Q24, szOne, MAX_PATH * 4); 
                           LoadString(hInst, ITA_Q25, szTwo, sizeof(szTwo)); 
                           LoadString(hInst, ITA_Q26, szThree, sizeof(szThree)); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNK), szTwo); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNKTWO), szThree); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), szOne); 
                      break; 
                      
                      case GLOBAL_LANGUAGE_SWEDISH: 
                           LoadString(hInst, SVE_Q24, szOne, MAX_PATH * 4); 
                           LoadString(hInst, SVE_Q25, szTwo, sizeof(szTwo)); 
                           LoadString(hInst, SVE_Q26, szThree, sizeof(szThree)); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNK), szTwo); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNKTWO), szThree); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), szOne); 
                      break; 
                      
                      case GLOBAL_LANGUAGE_FRENCH: 
                           LoadString(hInst, FRA_Q24, szOne, MAX_PATH * 4); 
                           LoadString(hInst, FRA_Q25, szTwo, sizeof(szTwo)); 
                           LoadString(hInst, FRA_Q26, szThree, sizeof(szThree)); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNK), szTwo); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNKTWO), szThree); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), szOne); 
                      break; 
                      
                      case GLOBAL_LANGUAGE_FINNISH:
                           LoadString(hInst, FIN_Q24, szOne, MAX_PATH * 4); 
                           LoadString(hInst, FIN_Q25, szTwo, sizeof(szTwo)); 
                           LoadString(hInst, FIN_Q26, szThree, sizeof(szThree)); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNK), szTwo); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNKTWO), szThree); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), szOne); 
                      break; 
                      
                      case GLOBAL_LANGUAGE_POLISH:
                           LoadString(hInst, POL_Q24, szOne, MAX_PATH * 4); 
                           LoadString(hInst, POL_Q25, szTwo, sizeof(szTwo)); 
                           LoadString(hInst, POL_Q26, szThree, sizeof(szThree)); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNK), szTwo); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNKTWO), szThree); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), szOne); 
                      break; 
                      
                      case GLOBAL_LANGUAGE_GERMAN:
                           LoadString(hInst, GER_Q24, szOne, MAX_PATH * 4); 
                           LoadString(hInst, GER_Q25, szTwo, sizeof(szTwo)); 
                           LoadString(hInst, GER_Q26, szThree, sizeof(szThree)); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNK), szTwo); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_HYLNKTWO), szThree); 
                           SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT_TEXT), szOne); 
                      break; 
                      
                      
                  }
                  
             }
             return TRUE;
             
             case WM_DESTROY:
                   EndDialog(hDlgWnd, 0);
             return TRUE;
	   
	         case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
             break;
             
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_HYLNK:
                         {
                              ShellExecute(hDlgWnd, "open", "http://raproducts.org", NULL, NULL, SW_SHOWNORMAL);
                              return TRUE;
                         }     
                         
                         case IDB_HYLNKTWO:
                         {
                              ShellExecute(hDlgWnd, "open", "http://lunarsoft.net/forum/index.php?showforum=45", NULL, NULL, SW_SHOWNORMAL);
                              return TRUE;
                         }
                  }
                  break;
             }
             break;
      }
      return FALSE; 
}     

BOOL CALLBACK InstDlgProc (HWND hDlgWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam)
{
       switch (message)
       {
       
             case WM_DESTROY:
		   	       EndDialog(hDlgWnd, 0);
             return TRUE;
	   
	         case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
             break;
             
             case WM_INITDIALOG:
             {
                  char szOne[MAX_PATH * 3]; 
                  char szTwo[MAX_PATH];
                  
                  switch(globalLanguageChosen)
                  {
                        case GLOBAL_LANGUAGE_DUTCH:
                             LoadString(hInst, DUT_Q27, szOne, MAX_PATH * 3);
                             LoadString(hInst, DUT_Q28, szTwo, sizeof(szTwo));  
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_UINST), szOne);
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_PAGE), szTwo); 
                        break;
                        
                        case GLOBAL_LANGUAGE_SPANISH:
                             LoadString(hInst, ESP_Q27, szOne, MAX_PATH * 3);
                             LoadString(hInst, ESP_Q28, szTwo, MAX_PATH); 
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_UINST), szOne);
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_PAGE), szTwo);
                        break;
                        
                        case GLOBAL_LANGUAGE_ITALIAN:
                             LoadString(hInst, ITA_Q27, szOne, MAX_PATH * 3);
                             LoadString(hInst, ITA_Q28, szTwo, MAX_PATH); 
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_UINST), szOne);
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_PAGE), szTwo);
                        break;
                        
                        case GLOBAL_LANGUAGE_SWEDISH: 
                             LoadString(hInst, SVE_Q27, szOne, MAX_PATH * 3);
                             LoadString(hInst, SVE_Q28, szTwo, MAX_PATH); 
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_UINST), szOne);
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_PAGE), szTwo);
                        break; 
                        
                        case GLOBAL_LANGUAGE_FRENCH: 
                             LoadString(hInst, FRA_Q27, szOne, MAX_PATH * 3);
                             LoadString(hInst, FRA_Q28, szTwo, MAX_PATH); 
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_UINST), szOne);
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_PAGE), szTwo);
                        break;
                        
                        case GLOBAL_LANGUAGE_FINNISH: 
                             LoadString(hInst, FIN_Q27, szOne, MAX_PATH * 3);
                             LoadString(hInst, FIN_Q28, szTwo, MAX_PATH); 
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_UINST), szOne);
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_PAGE), szTwo);
                        break; 
                        case GLOBAL_LANGUAGE_POLISH: 
                             LoadString(hInst, POL_Q27, szOne, MAX_PATH * 3);
                             LoadString(hInst, POL_Q28, szTwo, MAX_PATH); 
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_UINST), szOne);
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_PAGE), szTwo);
                        break; 
                        case GLOBAL_LANGUAGE_GERMAN: 
                             LoadString(hInst, GER_Q27, szOne, MAX_PATH * 3);
                             LoadString(hInst, GER_Q28, szTwo, MAX_PATH); 
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_UINST), szOne);
                             SetWindowText(GetDlgItem(hDlgWnd, IDB_PAGE), szTwo);
                        break; 
                  }
             }
             break;               
             
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_PAGE:
                         {
                              ShellExecute(NULL, "open", "http://java.sun.com/javase/downloads/index.jsp", NULL, NULL, SW_SHOWNORMAL);
                         }
                         break;
                  }
                  break;
             }
             break;
       }
       
       return FALSE;
}

BOOL CALLBACK UpdateDlgProc (HWND hDlgWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam)
{
       switch (message)
       {
       
             case WM_DESTROY:
		   	       EndDialog(hDlgWnd, 0);
             return TRUE;
	   
	         case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
             break;
             
             case WM_INITDIALOG:
             {
                  TCHAR szOne[MAX_PATH];
                  TCHAR szTwo[MAX_PATH];
                  TCHAR szThree[MAX_PATH];
                  TCHAR szFour[MAX_PATH];
                  TCHAR szFive[MAX_PATH];
                  TCHAR szSix[MAX_PATH]; 
                  TCHAR szSeven[MAX_PATH]; 
                  
                  switch(globalLanguageChosen)
                  {
                       case GLOBAL_LANGUAGE_DUTCH:
                            LoadString(hInst, DUT_Q18, szOne, sizeof(szOne));
                            LoadString(hInst, DUT_Q19, szTwo, sizeof(szTwo)); 
                            LoadString(hInst, DUT_Q20, szThree, sizeof(szThree)); 
                            LoadString(hInst, DUT_Q21, szFour, sizeof(szFour));
                            LoadString(hInst, DUT_Q22, szFive, sizeof(szFive)); 
                            LoadString(hInst, DUT_Q23, szSix, sizeof(szSix));
                            LoadString(hInst, DUT_Q5, szSeven, sizeof(szSeven)); 
                            SetWindowText(hDlgWnd, szSeven); 
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDMAIN), szOne);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UJAVA), szTwo);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_NWRVRS), szThree);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_USUN), szFour);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UNSURE), szFive);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UGO), szSix);
                       break;
                       
                       case GLOBAL_LANGUAGE_SPANISH:
                            LoadString(hInst, ESP_Q18, szOne, sizeof(szOne));
                            LoadString(hInst, ESP_Q19, szTwo, sizeof(szTwo)); 
                            LoadString(hInst, ESP_Q20, szThree, sizeof(szThree)); 
                            LoadString(hInst, ESP_Q21, szFour, sizeof(szFour));
                            LoadString(hInst, ESP_Q22, szFive, sizeof(szFive)); 
                            LoadString(hInst, ESP_Q23, szSix, sizeof(szSix));
                            LoadString(hInst, ESP_Q5, szSeven, sizeof(szSeven)); 
                            SetWindowText(hDlgWnd, szSeven); 
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDMAIN), szOne);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UJAVA), szTwo);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_NWRVRS), szThree);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_USUN), szFour);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UNSURE), szFive);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UGO), szSix);
                       break;
                       
                       case GLOBAL_LANGUAGE_ITALIAN:
                            LoadString(hInst, ITA_Q18, szOne, sizeof(szOne));
                            LoadString(hInst, ITA_Q19, szTwo, sizeof(szTwo)); 
                            LoadString(hInst, ITA_Q20, szThree, sizeof(szThree)); 
                            LoadString(hInst, ITA_Q21, szFour, sizeof(szFour));
                            LoadString(hInst, ITA_Q22, szFive, sizeof(szFive)); 
                            LoadString(hInst, ITA_Q23, szSix, sizeof(szSix));
                            LoadString(hInst, ITA_Q5, szSeven, sizeof(szSeven)); 
                            SetWindowText(hDlgWnd, szSeven); 
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDMAIN), szOne);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UJAVA), szTwo);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_NWRVRS), szThree);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_USUN), szFour);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UNSURE), szFive);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UGO), szSix);
                       break;
                       
                       case GLOBAL_LANGUAGE_SWEDISH: 
                            LoadString(hInst, SVE_Q18, szOne, sizeof(szOne));
                            LoadString(hInst, SVE_Q19, szTwo, sizeof(szTwo)); 
                            LoadString(hInst, SVE_Q20, szThree, sizeof(szThree)); 
                            LoadString(hInst, SVE_Q21, szFour, sizeof(szFour));
                            LoadString(hInst, SVE_Q22, szFive, sizeof(szFive)); 
                            LoadString(hInst, SVE_Q23, szSix, sizeof(szSix));
                            LoadString(hInst, SVE_Q5, szSeven, sizeof(szSeven)); 
                            SetWindowText(hDlgWnd, szSeven); 
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDMAIN), szOne);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UJAVA), szTwo);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_NWRVRS), szThree);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_USUN), szFour);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UNSURE), szFive);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UGO), szSix);
                       break;
                       
                       case GLOBAL_LANGUAGE_FRENCH:
                            LoadString(hInst, FRA_Q18, szOne, sizeof(szOne));
                            LoadString(hInst, FRA_Q19, szTwo, sizeof(szTwo)); 
                            LoadString(hInst, FRA_Q20, szThree, sizeof(szThree)); 
                            LoadString(hInst, FRA_Q21, szFour, sizeof(szFour));
                            LoadString(hInst, FRA_Q22, szFive, sizeof(szFive)); 
                            LoadString(hInst, FRA_Q23, szSix, sizeof(szSix));
                            LoadString(hInst, FRA_Q5, szSeven, sizeof(szSeven)); 
                            SetWindowText(hDlgWnd, szSeven); 
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDMAIN), szOne);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UJAVA), szTwo);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_NWRVRS), szThree);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_USUN), szFour);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UNSURE), szFive);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UGO), szSix);
                       break;
                       
                       case GLOBAL_LANGUAGE_FINNISH:
                            LoadString(hInst, FIN_Q18, szOne, sizeof(szOne));
                            LoadString(hInst, FIN_Q19, szTwo, sizeof(szTwo)); 
                            LoadString(hInst, FIN_Q20, szThree, sizeof(szThree)); 
                            LoadString(hInst, FIN_Q21, szFour, sizeof(szFour));
                            LoadString(hInst, FIN_Q22, szFive, sizeof(szFive)); 
                            LoadString(hInst, FIN_Q23, szSix, sizeof(szSix));
                            LoadString(hInst, FIN_Q5, szSeven, sizeof(szSeven)); 
                            SetWindowText(hDlgWnd, szSeven); 
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDMAIN), szOne);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UJAVA), szTwo);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_NWRVRS), szThree);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_USUN), szFour);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UNSURE), szFive);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UGO), szSix);
                       break; 
                       
                       case GLOBAL_LANGUAGE_POLISH:
                            LoadString(hInst, POL_Q18, szOne, sizeof(szOne));
                            LoadString(hInst, POL_Q19, szTwo, sizeof(szTwo)); 
                            LoadString(hInst, POL_Q20, szThree, sizeof(szThree)); 
                            LoadString(hInst, POL_Q21, szFour, sizeof(szFour));
                            LoadString(hInst, POL_Q22, szFive, sizeof(szFive)); 
                            LoadString(hInst, POL_Q23, szSix, sizeof(szSix));
                            LoadString(hInst, POL_Q5, szSeven, sizeof(szSeven)); 
                            SetWindowText(hDlgWnd, szSeven); 
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDMAIN), szOne);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UJAVA), szTwo);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_NWRVRS), szThree);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_USUN), szFour);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UNSURE), szFive);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UGO), szSix);
                       break;
                       
                       case GLOBAL_LANGUAGE_GERMAN:
                            LoadString(hInst, GER_Q18, szOne, sizeof(szOne));
                            LoadString(hInst, GER_Q19, szTwo, sizeof(szTwo)); 
                            LoadString(hInst, GER_Q20, szThree, sizeof(szThree)); 
                            LoadString(hInst, GER_Q21, szFour, sizeof(szFour));
                            LoadString(hInst, GER_Q22, szFive, sizeof(szFive)); 
                            LoadString(hInst, GER_Q23, szSix, sizeof(szSix));
                            LoadString(hInst, GER_Q5, szSeven, sizeof(szSeven)); 
                            SetWindowText(hDlgWnd, szSeven); 
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDMAIN), szOne);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UJAVA), szTwo);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_NWRVRS), szThree);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_USUN), szFour);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UNSURE), szFive);
                            SetWindowText(GetDlgItem(hDlgWnd, IDB_UGO), szSix);
                       break;  
                       
                       
                  }
             }
             break;
             
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_UGO:
                         {
                              int checkOne = SendMessage( GetDlgItem(hDlgWnd, IDB_UJAVA), BM_GETCHECK, 0, 0 );
                              int checkTwo = SendMessage( GetDlgItem(hDlgWnd, IDB_USUN), BM_GETCHECK, 0, 0 );
                              
                              if (checkOne == BST_CHECKED)
                              {
                                   char javaEnvironmentVariable[MAX_PATH];
                                   char fileToOpen[MAX_PATH];
                                   ZeroMemory(fileToOpen, MAX_PATH); 
                                   ZeroMemory(javaEnvironmentVariable, MAX_PATH); 
                     
                                   GetEnvironmentVariable("PROGRAMFILES", javaEnvironmentVariable, MAX_PATH);
                                   GetEnvironmentVariable("PROGRAMFILES", fileToOpen, MAX_PATH);
                     
                                   lstrcpy(fileToOpen, javaEnvironmentVariable);
                                   lstrcat(fileToOpen, "\\Java"); 
                                   lstrcat(javaEnvironmentVariable, "\\Java\\jre*");
                                   
                     
                                   WIN32_FIND_DATA FindFileData;
                                   HANDLE hHandle = FindFirstFile(javaEnvironmentVariable, &FindFileData); 
                     
                                   lstrcat(fileToOpen, "\\");
                                   lstrcat(fileToOpen, FindFileData.cFileName); 
                                   lstrcat(fileToOpen, "\\bin\\jucheck.exe"); 
                                   
                                   if ( ShellExecute(NULL, "open", fileToOpen, NULL, NULL, SW_SHOWNORMAL) != 0 )
                                   {
                                        while (FindNextFile(hHandle, &FindFileData) != 0)
                                        {
                                              ShellExecute(NULL, "open", fileToOpen, NULL, NULL, SW_SHOWNORMAL);
                                        }
                                   }
                              
                                   FindClose(hHandle); 
                                   return TRUE; 
                              
                              }
                              
                              else if (checkTwo == BST_CHECKED)
                              {
                                   DialogBox(hInst, "INST_DIALOG", hDlgWnd, InstDlgProc); 
                              }
                         }
                         break;
                  }
                  break;
             }
             break; 
       }
       

        return FALSE; 
}

int removeSDM()
{
    DeleteAny("PROGRAMFILES", "\\SDM20");
    DeleteAny("USERPROFILE", "\\.SunDownloadManager"); 
    DeleteAny("USERPROFILE", "\\Start Menu\\Programs\\Sun Download Manager 2.0 (local)");
    DeleteAny("USERPROFILE", "\\Desktop\\Sun Download Manager 2.0 (local).lnk");
    
    char homeDrive[MAX_PATH];
    ZeroMemory(homeDrive, MAX_PATH); 
    GetEnvironmentVariable("HOMEDRIVE", homeDrive, 80);
    lstrcat(homeDrive, "\\Documents and Settings\\Administrator\\.SunDownloadManager");
    
    char logname[MAX_PATH];
    ZeroMemory(logname, MAX_PATH); 
    GetEnvironmentVariable("HOMEDRIVE", logname, 100);
    strcat(logname, "\\JavaRa.log");
                       
    FILE *fp;
    fp = fopen(logname, "a");
    
    char temp[255];
    memset( temp, 0, sizeof(temp) );
    SHFILEOPSTRUCT folderFunction;
    memset( &folderFunction, 0, sizeof(folderFunction) );
    lstrcat(temp, homeDrive);
    lstrcat(temp, "\0");
    
    folderFunction.hwnd = NULL;
    folderFunction.wFunc = FO_DELETE;
    folderFunction.pFrom = temp; 
    folderFunction.pTo = NULL;
    folderFunction.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI;
    int fileOperationCheck = SHFileOperation(&folderFunction);
    
    switch(fileOperationCheck)
    {
        case 0:
             fprintf(fp, "Found and removed: %s\r\n", temp);
        break;
        
        case ERROR_ACCESS_DENIED:
             fprintf(fp, "Could not delete: %s\r\n\r\nAsking Windows to delete %s on reboot.", temp);
             MoveFileEx(temp, NULL, MOVEFILE_DELAY_UNTIL_REBOOT);
        break;
        
        case ERROR_FILE_NOT_FOUND:
        //     fprintf(fp, "Did not find: %s\r\n", temp);
        break;
        
        case 1026:
        //      fprintf(fp, "Did not find: %s\r\n", temp);
        break;
        
        default:
        //     fprintf(fp, "There was an error removing %s. The error returned was %i.\r\n", temp, fileOperationCheck);
        break;
    }
    fclose(fp);
}

int purgeFiles()
{
    char javaEnvironmentVariable[MAX_PATH];
    char tempEnvironmentVariable[MAX_PATH];
    char system32EnvironmentVariable[MAX_PATH];
                                     
    ZeroMemory(javaEnvironmentVariable, MAX_PATH); 
    ZeroMemory(tempEnvironmentVariable, MAX_PATH);
    ZeroMemory(system32EnvironmentVariable, MAX_PATH);
                                      
    char javaPathRemember[MAX_PATH];
                                     
    GetEnvironmentVariable("PROGRAMFILES", javaEnvironmentVariable, MAX_PATH);
    GetEnvironmentVariable("PROGRAMFILES", javaPathRemember, MAX_PATH);
    GetEnvironmentVariable("TEMP", tempEnvironmentVariable, MAX_PATH);
    GetEnvironmentVariable("windir", system32EnvironmentVariable, MAX_PATH); 
                                      
    lstrcat(javaEnvironmentVariable, "\\Java\\jre*");
    lstrcat(javaPathRemember, "\\Java\\");
    lstrcat(system32EnvironmentVariable, "\\system32");
                                       
    DeleteUselessJavaFiles(javaPathRemember, javaEnvironmentVariable, "\\*.ERR");
    DeleteTempFilesJava(tempEnvironmentVariable, "java_*.log"); 
    DeleteTempFilesJava(tempEnvironmentVariable, "jusched.log"); 
    DeleteTempFilesJava(system32EnvironmentVariable, "jupdate*.log"); 
}

int RunJRERemove(bool silent)
{
                          char szOne[MAX_PATH];
                          char szTwo[MAX_PATH]; 
                          char szThree[MAX_PATH];
                          ZeroMemory(szOne, MAX_PATH); 
                          ZeroMemory(szTwo, MAX_PATH); 
                          ZeroMemory(szThree, MAX_PATH); 
                          
                          if ( silent != true) 
                          {
                          
                              switch(globalLanguageChosen)
                              {
                                    case GLOBAL_LANGUAGE_ENGLISH:
                                         lstrcpy(szOne, "In order for JavaRa to do its job in the most thorough way possible, Internet Explorer needs to be closed. If you are using Internet Explorer, please close it now.");
                                        
                                    break; 
                                    case GLOBAL_LANGUAGE_DUTCH:
                                         lstrcpy(szOne, "Om JavaRa zo goed mogelijk te laten werken, moet Internet Explorer worden afgesloten. Als je Internet Explorer gebruik, sluit deze dan nu.");
                                         
                                    break; 
                                    case GLOBAL_LANGUAGE_SPANISH:
                                         lstrcpy(szOne, "Con el fin de que JavaRa haga su trabajo de la forma ms exhaustiva posible, Internet Explorer necesita cerrarse. Si ests usando Internet Explorer, por favor cirralo ahora.");
                                         
                                    break; 
                                    case GLOBAL_LANGUAGE_ITALIAN:
                                         lstrcpy(szOne, "Al fine di JavaRa a svolgere il proprio lavoro nel modo pi completo possibile, di Internet Explorer deve essere chiuso. Se si utilizza Internet Explorer, chiudere adesso.");
                                         
                                    break; 
                                    case GLOBAL_LANGUAGE_SWEDISH:
                                         lstrcpy(szOne, "Fr att JavaRa ska kunna gra sitt jobb p ett s genomgripande stt som mjligt, s br inte Internet Explorer kras. Om du anvnder Internet Explorer kan du stnga det nu.");
                                        
                                    break; 
                                    case GLOBAL_LANGUAGE_FINNISH:
                                         lstrcpy(szOne, "Internet Explorer on suljettava, jotta JavaRa voisi tehd tyns mahdollisimman perusteellisesti. Jos Internet Explorer on kynniss, ole hyv ja sulje se nyt.");
                                         
                                    break; 
                                    case GLOBAL_LANGUAGE_FRENCH:
                                         lstrcpy(szOne, "Afin que JavaRa puisse excuter son travail dans les meilleures conditions possibles, Internet Explorer doit tre ferm. Si vous tes en train d'utiliser Internet Explorer, veuillez le fermer maintenant.");
                                         
                                    break; 
                                    case GLOBAL_LANGUAGE_POLISH:
                                         lstrcpy(szOne, "Aby program JavaRa mg dokadnie wykona swoj prac, Twoja przegldarka musi by zamknita. Jeli jest ona otwarta, zamknij j teraz."); 
                                        
                                    break;
                                    case GLOBAL_LANGUAGE_GERMAN:
                                          lstrcpy (szOne, "Um zu JavaRa zu tun seinen Job in der grndlichste Weise mglich, im Internet Explorer geschlossen werden muss. Wenn Sie Internet Explorer, schlieen Sie es jetzt.");
                                          
                                     break;
                              }
                              
                              MessageBox(0, szOne, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION);
                              ZeroMemory(szOne, MAX_PATH); 
                          
                          }
                          
                          char logname[MAX_PATH];
                          ZeroMemory(logname, MAX_PATH); 
                          GetEnvironmentVariable("HOMEDRIVE", logname, 100);
                          strcat(logname, "\\JavaRa.log");
                          
                          FILE *fp;
                          fp = fopen(logname, "a");
                          
                          fputs("JavaRa 1.15 Removal Log.\r\nReport follows after line.\r\n", fp);
                          fputs("------------------------------------\r\n", fp);
                          time_t rawtime;
                          time ( &rawtime );
                          fprintf ( fp, "The JavaRa removal process was started on %s\n", ctime(&rawtime) );
                          fclose(fp);
                          
                          KillProcess("jucheck.exe"); 
                          KillProcess("jusched.exe"); 
                          
                          char buffer[MAX_PATH];
                          char temp[MAX_PATH];
                          char javaEnvironmentVariable[MAX_PATH];
                          char fileToRemember[MAX_PATH];
                          
                          ZeroMemory(fileToRemember, MAX_PATH); 
                          ZeroMemory(javaEnvironmentVariable, MAX_PATH); 
                          ZeroMemory(temp, MAX_PATH); 
                          ZeroMemory(buffer, MAX_PATH); 
                          
                          
                                                    
                          char javaPathRemember[MAX_PATH];
                          ZeroMemory(javaPathRemember, MAX_PATH); 
                                                   
                          GetEnvironmentVariable("PROGRAMFILES", javaEnvironmentVariable, MAX_PATH);
                          GetEnvironmentVariable("PROGRAMFILES", javaPathRemember, MAX_PATH);
                           
                          lstrcat(javaEnvironmentVariable, "\\Java\\j*re*");
                          lstrcat(javaPathRemember, "\\Java\\");
                          
                          WIN32_FIND_DATA FindFileData;
                          
                          HANDLE hHandle = FindFirstFile(javaEnvironmentVariable, &FindFileData); 
                          lstrcpy(fileToRemember, FindFileData.cFileName);
                                                    
                           while (FindNextFile(hHandle, &FindFileData) != 0) 
                           {
                                
                                int check; 
                                
                                for ( int i = 0; i < 12; i++ )
                                {
                                    check = strncmp(fileToRemember, FindFileData.cFileName, i);
                                    if ( check > 0 )
                                       check = STR_HIGHER;
                                    else if ( check < 0 )
                                       check = STR_LOWER; 
                                    else if ( check == 0 ) 
                                       check = STR_EQUAL; 
                                       
                                    switch(check) 
                                    {
                                        case STR_HIGHER: 
                                            sprintf(temp, "Removed %s%s.\n", javaPathRemember, FindFileData.cFileName);
                                            lstrcat(buffer, temp); 
                                            RemoveFolders(javaPathRemember, FindFileData.cFileName);
                                            ZeroMemory(fileToRemember, MAX_PATH);
                                            lstrcpy(fileToRemember, FindFileData.cFileName);  
                                        break; 
                                         
                                        
                                        case STR_LOWER:  
                                             sprintf(temp, "Removed %s%s.\n", javaPathRemember, fileToRemember);
                                             lstrcat(buffer, temp); 
                                             RemoveFolders(javaPathRemember, fileToRemember); 
                                             ZeroMemory(fileToRemember, MAX_PATH); 
                                             lstrcpy(fileToRemember, FindFileData.cFileName);
                                        break;
                                    }
                                }
                           }                     
                          
                           FindClose(hHandle); 
                           ZeroMemory(fileToRemember, MAX_PATH); 
                          
                           int getSystem = GetSystemVersion();
                           switch(getSystem)
                           {
                                   case SYSTEM_VERSION_VISTA: 
                                       
                                        DeleteAny("USERPROFILE", "\\AppData\\Roaming\\Microsoft\\Windows\\Start Menu\\Java Plug-in Control Panel.ink"); 
                                        DeleteAny("PUBLIC", "\\Desktop\\Java Web Start.lnk"); 
                                        
                                        char appDataJavaPath[MAX_PATH];
                                        char appPathToRemember[MAX_PATH];
                                        
                                        GetEnvironmentVariable("USERPROFILE", appDataJavaPath, MAX_PATH);
                                        lstrcat(appDataJavaPath, "\\AppData\\LocalLow\\Sun\\Java\\j*re*"); 
                                        GetEnvironmentVariable("USERPROFILE", appPathToRemember, MAX_PATH);
                                        lstrcat(appPathToRemember, "\\AppData\\LocalLow\\Sun\\Java\\"); 
                                        hHandle = FindFirstFile(appDataJavaPath, &FindFileData); 
                                        lstrcpy(fileToRemember, FindFileData.cFileName);
                                                    
                                        while (FindNextFile(hHandle, &FindFileData) != 0) {
                                              for ( int i = 0; i < 12; i++ ) {
                                              int check = strncmp(fileToRemember, FindFileData.cFileName, i);
                                              
                                              if ( check > 0 )
                                                 check = STR_HIGHER;
                                              else if ( check < 0 )
                                                 check = STR_LOWER; 
                                              else if ( check == 0 ) 
                                                 check = STR_EQUAL; 
                                              
                                              switch(check) {
                                                            case STR_HIGHER: 
                                                                 sprintf(temp, "Removed %s%s.\n", appPathToRemember, FindFileData.cFileName);
                                                                 lstrcat(buffer, temp); 
                                                                 RemoveFolders(appPathToRemember, FindFileData.cFileName);
                                                                 ZeroMemory(fileToRemember, MAX_PATH);
                                                                 lstrcpy(fileToRemember, FindFileData.cFileName);  
                                                            break; 
                                         
                                        
                                                            case STR_LOWER:  
                                                                 sprintf(temp, "Removed %s%s.\n", appPathToRemember, fileToRemember);
                                                                 lstrcat(buffer, temp); 
                                                                 RemoveFolders(appPathToRemember, fileToRemember); 
                                                                 ZeroMemory(fileToRemember, MAX_PATH); 
                                                                 lstrcpy(fileToRemember, FindFileData.cFileName);
                                                            break;
                                              }
                                           }
                                        }                     
                          
                                        FindClose(hHandle); 
                                   break;
                                   
                                   case SYSTEM_VERSION_XP:
                                        DeleteAny("USERPROFILE", "\\Start Menu\\Programs\\Java Plug-in Control Panel.lnk");
                                        DeleteAny("ALLUSERSPROFILE", "\\Start Menu\\Programs\\Java 2 Runtime Environment");
                                        DeleteAny("USERPROFILE", "\\Local Settings\\Application Data\\{3248F0A6-6813-11D6-A77B-00B0D0150010}");
                                   
                                        char appJavaPath[MAX_PATH];
                                        char appToRemember[MAX_PATH];
                                        
                                        GetEnvironmentVariable("APPDATA", appJavaPath, MAX_PATH);
                                        lstrcat(appJavaPath, "\\Sun\\Java\\j*re*"); 
                                        GetEnvironmentVariable("APPDATA", appToRemember, MAX_PATH);
                                        lstrcat(appToRemember, "\\Sun\\Java\\"); 
                                        hHandle = FindFirstFile(appJavaPath, &FindFileData); 
                                        lstrcpy(fileToRemember, FindFileData.cFileName);
                                                    
                                        while (FindNextFile(hHandle, &FindFileData) != 0) {
                                              for ( int i = 0; i < 12; i++ ) {
                                              int check = strncmp(fileToRemember, FindFileData.cFileName, i);
                                              
                                              if ( check > 0 )
                                                 check = STR_HIGHER;
                                              else if ( check < 0 )
                                                 check = STR_LOWER; 
                                              else if ( check == 0 ) 
                                                 check = STR_EQUAL; 
                                              
                                              switch(check) {
                                                            case STR_HIGHER: 
                                                                 sprintf(temp, "Removed %s%s.\n", appToRemember, FindFileData.cFileName);
                                                                 lstrcat(buffer, temp); 
                                                                 RemoveFolders(appToRemember, FindFileData.cFileName);
                                                                 ZeroMemory(fileToRemember, MAX_PATH);
                                                                 lstrcpy(fileToRemember, FindFileData.cFileName);  
                                                            break; 
                                         
                                        
                                                            case STR_LOWER:  
                                                                 sprintf(temp, "Removed %s%s.\n", appToRemember, fileToRemember);
                                                                 lstrcat(buffer, temp); 
                                                                 RemoveFolders(appToRemember, fileToRemember); 
                                                                 ZeroMemory(fileToRemember, MAX_PATH); 
                                                                 lstrcpy(fileToRemember, FindFileData.cFileName);
                                                            break;
                                              }
                                           }
                                        }                     
                          
                                        FindClose(hHandle); 
                                        
                                        
                                   break; 
                           } 
                          
                           DeleteAny("HOMEDRIVE", "\\Windows\\_delis43.ini");
                           DeleteAny("HOMEDRIVE", "\\Windows\\jre.exe");
                           DeleteAny("HOMEDRIVE", "\\Windows\\jrew.exe");
                           DeleteAny("USERPROFILE", "\\Desktop\\Java Web Start.lnk"); 
                           DeleteAny("PROGRAMFILES", "\\Java Web Start");
                           DeleteAny("HOMEDRIVE", "\\Windows\\5390d.msi");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150010}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\System32\\jpicpl32.cpl");
                           DeleteAny("HOMEDRIVE", "\\Windows\\System32\\jupdate-1.5.0_01-b08.log");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142000}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142010}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142020}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142030}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142040}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142050}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142060}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142070}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142080}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142090}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142100}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142110}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142120}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142130}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142140}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142150}");
                           DeleteAny("HOMEDRIVE", "\\Windows\\Installer\\{7148F0A8-6813-11D6-A77B-00B0D0142160}");
                            
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_01.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_02.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_03.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_04.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_05.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_06.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_07.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_08.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_09.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_10.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_11.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_12.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_13.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_14.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_15.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_16.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_17.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_18.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_19.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl131_20.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl130.cpl"); 
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl130_01.cpl");
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl130_02.cpl");
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl130_03.cpl");
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl130_04.cpl");
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl130_05.cpl");
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl140.cpl");
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl140_01.cpl");
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl140_02.cpl");
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl140_03.cpl");
                           DeleteAny("HOMEDRIVE", "\\WINDOWS\\system32\\plugincpl140_04.cpl");


                          char registryHive[MAX_PATH];
                          ZeroMemory ( registryHive, MAX_PATH );
                        
                          FILE * ep = fopen( "JavaRa.def", "r" );
                          
                          if ( ep != NULL ) 
                          {
                               while ( fgets(registryHive, MAX_PATH, ep) ) 
                               {  
                                     HKEY regHandle; 
                              
                                     char* pHive = registryHive;
                                     char* pKey = registryHive; 
                              
                                     while( *pKey != '\\' ) 
                                     {
                                            pKey++; 
                                            if ( *pKey == '\0' )
                                               break; 
                                     }
                              
                                     *(pKey++) = '\0';
                              
                                     char * otherKey;
                                     otherKey = strtok(pKey, "\n"); 
                              
                                     if ( strcmp(pHive, "HKEY_LOCAL_MACHINE") == 0  ) 
                                        regHandle = HKEY_LOCAL_MACHINE;
                                     else if ( strcmp(pHive, "HKEY_CURRENT_USER") == 0 ) 
                                        regHandle = HKEY_CURRENT_USER; 
                              
                                     RemoveRegKeys(regHandle, otherKey, true); 
                              }
                              
                              fclose(ep);
                          }        
                          
                         else if ( ep == NULL && silent != true ) { 
                                char message[MAX_PATH] = "Could not find JavaRa.def! Be sure the definition file resides in the same directory JavaRa.exe is in.";
                                
                                switch ( globalLanguageChosen ) { 
                                       case GLOBAL_LANGUAGE_DUTCH: 
                                            lstrcpy(message, "Kan niet vinden JavaRa.def! Wees er zeker van de definitie-bestand bevindt zich in dezelfde directory JavaRa.exe zich bevindt.");
                                       break;
                                       case GLOBAL_LANGUAGE_SPANISH: 
                                            lstrcpy(message, "No se pudo encontrar JavaRa.def! Asegrese de que el archivo de definicin reside en el mismo directorio que se encuentra JavaRa.exe.");
                                       break;
                                       case GLOBAL_LANGUAGE_ITALIAN: 
                                            lstrcpy(message, "Impossibile trovare JavaRa.def! Assicurarsi che il file di definizione risiede nella stessa directory si trova JavaRa.exe.");
                                       break;
                                       case GLOBAL_LANGUAGE_SWEDISH: 
                                            lstrcpy(message, "Kunde inte hitta JavaRa.def! Var noga med definitionen filen finns i samma katalog JavaRa.exe r i.");
                                       break;
                                       case GLOBAL_LANGUAGE_FRENCH:
                                            lstrcpy(message, "Impossible de trouver JavaRa.def! Assurez-vous que le fichier de dfinition rside dans le mme rpertoire JavaRa.exe est po.");
                                       break;
                                       case GLOBAL_LANGUAGE_FINNISH:
                                            lstrcpy(message, "Ei lytynyt JavaRa.def! Varmista, ett mritelm tiedosto asuu samassa hakemistossa JavaRa.exe on sisn.");
                                       break;
                                       case GLOBAL_LANGUAGE_POLISH: 
                                            lstrcpy(message, "Nie moz.na znalez'c' JavaRa.def! Upewnij sie;, z.e plik definicji mieszka w tym samym katalogu JavaRa.exe jest cala.");
                                       break;
                                       case GLOBAL_LANGUAGE_GERMAN:
                                            lstrcpy(message, "Konnte nicht gefunden JavaRa.def! Stellen Sie sicher, dass die Definition Datei befindet sich im selben Verzeichnis JavaRa.exe ist in.");
                                       break;
                                }
                                
                                MessageBox(0, message, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION);
                          } 
                          
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_01\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_02\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_03\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_04\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_05\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_06\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_07\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_08\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_09\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_10\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_11\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_12\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_13\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_14\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150000}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150001}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150002}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150003}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150004}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150005}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150006}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150007}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150008}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150009}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151000}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151001}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151002}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151003}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151004}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core1.zip\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core2.zip\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core3.zip\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_01\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_02\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_03\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_04\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_05\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_06\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_01\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_02\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_03\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_04\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_05\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_06\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_07\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_01\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_02\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_03\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_04\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_05\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_06\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_01\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_02\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_03\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_04\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_05\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_06\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_01\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_02\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_03\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_04\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_05\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_06\\lib\\ext\\QTJava.zip", true);  
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_01\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_02\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_03\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_04\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_05\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_06\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Java\\jre1.5.0_01\\", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150010}\\", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_01.b06\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_02.b06\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_03.b05\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_04.b12\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_05.b13\\", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_06.b02\\", true);   
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core1.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core2.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core3.zip", true);  
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410200", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410201", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410202", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410203", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410204", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410205", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410206", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410207", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410208", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410209", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411200", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411201", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411202", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411203", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411204", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411205", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411206", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410200", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410201", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410202", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410203", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410204", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410205", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410206", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410207", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410208", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410209", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411200", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411201", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411202", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411203", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411204", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411205", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411206", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_01\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_02\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_03\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_04\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_05\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_06\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_07\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_08\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_09\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_10\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_11\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_12\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_13\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.5.0_14\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150000}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150001}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150002}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150003}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150004}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150005}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150006}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150007}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150008}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150009}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151000}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151001}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151002}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151003}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0151004}", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core1.zip\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core2.zip\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core3.zip\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_01\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_02\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_03\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_04\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_05\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_06\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_01\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_02\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_03\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_04\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_05\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_06\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders\\", "C:\\Program Files\\Java\\jre1.6.0_07\\bin\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_01\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_02\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_03\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_04\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_05\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet001\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_06\\lib\\ext\\QTJava.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_01\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_02\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_03\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_04\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_05\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\ControlSet003\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_06\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_01\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_02\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_03\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_04\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_05\\lib\\ext\\QTJava.zip", true);           
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment\\", "C:\\Program Files\\Java\\jre1.6.0_06\\lib\\ext\\QTJava.zip", true);  
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_01\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_02\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_03\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_04\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_05\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\Installer\\Products\\{4F4A3A23297B6D117AA8000B0D610001}\\SourceList\\", "C:\\Program Files\\Java\\jre1.6.0_06\\lib\\ext\\QTJava.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Java\\jre1.5.0_01\\", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\WINDOWS\\Installer\\{3248F0A8-6813-11D6-A77B-00B0D0150010}\\", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_01.b06\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_02.b06\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_03.b05\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_04.b12\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_05.b13\\", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\Folders", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.6.0.b105\\patch-jre1.6.0_06.b02\\", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core1.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core2.zip", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\SharedDlls", "C:\\Program Files\\Common Files\\Java\\Update\\Base Images\\jre1.5.0.b64\\core3.zip", true); 
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410200", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410201", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410202", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410203", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410204", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410205", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410206", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410207", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410208", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D410209", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411200", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411201", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411202", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411203", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411204", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411205", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Components", "ACB9B14518A96D117A58000B0D411206", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410200", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410201", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410202", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410203", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410204", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410205", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410206", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410207", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410208", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D410209", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411200", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411201", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411202", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411203", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411204", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411205", true);
                          RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Installer\\UserData\\S-1-5-18\\Products", "8A0F841731866D117AB7000B0D411206", true);
                          
                          DeleteAny("PROGRAMFILES", "\\JavaSoft"); 
                          
                          fp = fopen(logname, "a");
                          fputs("------------------------------------\r\nFinished reporting.\r\n\r\n", fp);
                          fclose(fp); 
                          
                          if ( strcmp(temp, "") != 0 && silent != true) 
                          {
                               MessageBox(0, buffer, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION); 
                          }
                          
                          return FALSE; 
}

BOOL CALLBACK OptionsDlgProc (HWND hDlgWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
       switch (message)
       {
       
             case WM_DESTROY:
		   	       EndDialog(hDlgWnd, 0);
             return TRUE;
	   
	         case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
             break;
             
             case WM_INITDIALOG:
             {
                  TCHAR szOne[MAX_PATH];
                  TCHAR szTwo[MAX_PATH];
                  TCHAR szThree[MAX_PATH];
                  TCHAR szFour[MAX_PATH];
                  TCHAR szFive[MAX_PATH];
                  TCHAR szSix[MAX_PATH]; 
                  TCHAR szSeven[MAX_PATH]; 
                  TCHAR szEight[MAX_PATH];
                  TCHAR szNine[MAX_PATH]; 
                  TCHAR szTen[MAX_PATH];
                  TCHAR szEleven[MAX_PATH]; 
                  
                  switch(globalLanguageChosen)
                  {
                        case GLOBAL_LANGUAGE_DUTCH:
                              LoadString(hInst, DUT_Q7, szOne, sizeof(szOne)); 
                              LoadString(hInst, DUT_Q9, szTwo, sizeof(szTwo)); 
                              LoadString(hInst, DUT_Q10, szThree, sizeof(szThree)); 
                              LoadString(hInst, DUT_Q11, szFour,  sizeof(szFour)); 
                              LoadString(hInst, DUT_Q12, szFive, sizeof(szFive)); 
                              LoadString(hInst, DUT_Q13, szSix, sizeof(szSix));
                              LoadString(hInst, DUT_Q14, szSeven, sizeof(szSeven)); 
                              LoadString(hInst, DUT_Q15, szEight, sizeof(szEight)); 
                              LoadString(hInst, DUT_Q17, szNine, sizeof(szNine)); 
                              LoadString(hInst, DUT_Q31, szTen, sizeof(szTen)); 
                              LoadString(hInst, DUT_Q32, szEleven, sizeof(szEleven)); 
                              SetWindowText(hDlgWnd, szOne); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CLEAN), szTwo);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_STARTUP), szThree); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_SDMRM), szFour); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDATE), szFive);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_OPNLG), szSix); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_JRLOG), szSeven); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_GO), szEight);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_DONATE), szNine);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_RMREG), szTen); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CHKVER), szEleven); 
                        break; 
                        
                        case GLOBAL_LANGUAGE_SPANISH:
                              LoadString(hInst, ESP_Q7, szOne, sizeof(szOne)); 
                              LoadString(hInst, ESP_Q9, szTwo, sizeof(szTwo)); 
                              LoadString(hInst, ESP_Q10, szThree, sizeof(szThree)); 
                              LoadString(hInst, ESP_Q11, szFour,  sizeof(szFour)); 
                              LoadString(hInst, ESP_Q12, szFive, sizeof(szFive)); 
                              LoadString(hInst, ESP_Q13, szSix, sizeof(szSix));
                              LoadString(hInst, ESP_Q14, szSeven, sizeof(szSeven)); 
                              LoadString(hInst, ESP_Q15, szEight, sizeof(szEight)); 
                              LoadString(hInst, ESP_Q17, szNine, sizeof(szNine)); 
                              LoadString(hInst, ESP_Q31, szTen, sizeof(szTen)); 
                              LoadString(hInst, ESP_Q32, szEleven, sizeof(szEleven)); 
                              SetWindowText(hDlgWnd, szOne); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CLEAN), szTwo);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_STARTUP), szThree); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_SDMRM), szFour); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDATE), szFive);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_OPNLG), szSix); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_JRLOG), szSeven); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_GO), szEight);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_DONATE), szNine);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_RMREG), szTen); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CHKVER), szEleven);
                        break;
                        
                        case GLOBAL_LANGUAGE_ITALIAN:
                              LoadString(hInst, ITA_Q7, szOne, sizeof(szOne)); 
                              LoadString(hInst, ITA_Q9, szTwo, sizeof(szTwo)); 
                              LoadString(hInst, ITA_Q10, szThree, sizeof(szThree)); 
                              LoadString(hInst, ITA_Q11, szFour,  sizeof(szFour)); 
                              LoadString(hInst, ITA_Q12, szFive, sizeof(szFive)); 
                              LoadString(hInst, ITA_Q13, szSix, sizeof(szSix));
                              LoadString(hInst, ITA_Q14, szSeven, sizeof(szSeven)); 
                              LoadString(hInst, ITA_Q15, szEight, sizeof(szEight)); 
                              LoadString(hInst, ITA_Q17, szNine, sizeof(szNine)); 
                              LoadString(hInst, ITA_Q31, szTen, sizeof(szTen)); 
                              LoadString(hInst, ITA_Q32, szEleven, sizeof(szEleven)); 
                              SetWindowText(hDlgWnd, szOne); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CLEAN), szTwo);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_STARTUP), szThree); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_SDMRM), szFour); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDATE), szFive);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_OPNLG), szSix); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_JRLOG), szSeven); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_GO), szEight);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_DONATE), szNine);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_RMREG), szTen); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CHKVER), szEleven);
                        break;
                        
                        case GLOBAL_LANGUAGE_SWEDISH:
                             LoadString(hInst, SVE_Q7, szOne, sizeof(szOne)); 
                              LoadString(hInst, SVE_Q9, szTwo, sizeof(szTwo)); 
                              LoadString(hInst, SVE_Q10, szThree, sizeof(szThree)); 
                              LoadString(hInst, SVE_Q11, szFour,  sizeof(szFour)); 
                              LoadString(hInst, SVE_Q12, szFive, sizeof(szFive)); 
                              LoadString(hInst, SVE_Q13, szSix, sizeof(szSix));
                              LoadString(hInst, SVE_Q14, szSeven, sizeof(szSeven)); 
                              LoadString(hInst, SVE_Q15, szEight, sizeof(szEight)); 
                              LoadString(hInst, SVE_Q17, szNine, sizeof(szNine)); 
                              LoadString(hInst, SVE_Q31, szTen, sizeof(szTen)); 
                              LoadString(hInst, SVE_Q32, szEleven, sizeof(szEleven)); 
                              SetWindowText(hDlgWnd, szOne); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CLEAN), szTwo);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_STARTUP), szThree); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_SDMRM), szFour); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDATE), szFive);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_OPNLG), szSix); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_JRLOG), szSeven); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_GO), szEight);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_DONATE), szNine);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_RMREG), szTen);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CHKVER), szEleven);
                        break;
                        
                        case GLOBAL_LANGUAGE_FRENCH:
                              LoadString(hInst, FRA_Q7, szOne, sizeof(szOne)); 
                              LoadString(hInst, FRA_Q9, szTwo, sizeof(szTwo)); 
                              LoadString(hInst, FRA_Q10, szThree, sizeof(szThree)); 
                              LoadString(hInst, FRA_Q11, szFour,  sizeof(szFour)); 
                              LoadString(hInst, FRA_Q12, szFive, sizeof(szFive)); 
                              LoadString(hInst, FRA_Q13, szSix, sizeof(szSix));
                              LoadString(hInst, FRA_Q14, szSeven, sizeof(szSeven)); 
                              LoadString(hInst, FRA_Q15, szEight, sizeof(szEight)); 
                              LoadString(hInst, FRA_Q17, szNine, sizeof(szNine)); 
                              LoadString(hInst, FRA_Q31, szTen, sizeof(szTen)); 
                              LoadString(hInst, FRA_Q32, szEleven, sizeof(szEleven)); 
                              SetWindowText(hDlgWnd, szOne); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CLEAN), szTwo);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_STARTUP), szThree); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_SDMRM), szFour); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDATE), szFive);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_OPNLG), szSix); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_JRLOG), szSeven); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_GO), szEight);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_DONATE), szNine);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_RMREG), szTen);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CHKVER), szEleven);
                        break; 
                        
                        case GLOBAL_LANGUAGE_FINNISH:
                              LoadString(hInst, FIN_Q7, szOne, sizeof(szOne)); 
                              LoadString(hInst, FIN_Q9, szTwo, sizeof(szTwo)); 
                              LoadString(hInst, FIN_Q10, szThree, sizeof(szThree)); 
                              LoadString(hInst, FIN_Q11, szFour,  sizeof(szFour)); 
                              LoadString(hInst, FIN_Q12, szFive, sizeof(szFive)); 
                              LoadString(hInst, FIN_Q13, szSix, sizeof(szSix));
                              LoadString(hInst, FIN_Q14, szSeven, sizeof(szSeven)); 
                              LoadString(hInst, FIN_Q15, szEight, sizeof(szEight)); 
                              LoadString(hInst, FIN_Q17, szNine, sizeof(szNine)); 
                              LoadString(hInst, FIN_Q31, szTen, sizeof(szTen)); 
                              LoadString(hInst, FIN_Q32, szEleven, sizeof(szEleven)); 
                              SetWindowText(hDlgWnd, szOne); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CLEAN), szTwo);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_STARTUP), szThree); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_SDMRM), szFour); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDATE), szFive);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_OPNLG), szSix); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_JRLOG), szSeven); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_GO), szEight);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_DONATE), szNine);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_RMREG), szTen);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CHKVER), szEleven);
                        break; 
                        
                        case GLOBAL_LANGUAGE_POLISH:
                              LoadString(hInst, POL_Q7, szOne, sizeof(szOne)); 
                              LoadString(hInst, POL_Q9, szTwo, sizeof(szTwo)); 
                              LoadString(hInst, POL_Q10, szThree, sizeof(szThree)); 
                              LoadString(hInst, POL_Q11, szFour,  sizeof(szFour)); 
                              LoadString(hInst, POL_Q12, szFive, sizeof(szFive)); 
                              LoadString(hInst, POL_Q13, szSix, sizeof(szSix));
                              LoadString(hInst, POL_Q14, szSeven, sizeof(szSeven)); 
                              LoadString(hInst, POL_Q15, szEight, sizeof(szEight)); 
                              LoadString(hInst, POL_Q17, szNine, sizeof(szNine)); 
                              LoadString(hInst, POL_Q31, szTen, sizeof(szTen)); 
                              LoadString(hInst, POL_Q32, szEleven, sizeof(szEleven)); 
                              SetWindowText(hDlgWnd, szOne); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CLEAN), szTwo);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_STARTUP), szThree); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_SDMRM), szFour); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDATE), szFive);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_OPNLG), szSix); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_JRLOG), szSeven); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_GO), szEight);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_DONATE), szNine);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_RMREG), szTen);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CHKVER), szEleven);
                        break; 
                        
                        case GLOBAL_LANGUAGE_GERMAN:
                              LoadString(hInst, GER_Q7, szOne, sizeof(szOne)); 
                              LoadString(hInst, GER_Q9, szTwo, sizeof(szTwo)); 
                              LoadString(hInst, GER_Q10, szThree, sizeof(szThree)); 
                              LoadString(hInst, GER_Q11, szFour,  sizeof(szFour)); 
                              LoadString(hInst, GER_Q12, szFive, sizeof(szFive)); 
                              LoadString(hInst, GER_Q13, szSix, sizeof(szSix));
                              LoadString(hInst, GER_Q14, szSeven, sizeof(szSeven)); 
                              LoadString(hInst, GER_Q15, szEight, sizeof(szEight)); 
                              LoadString(hInst, GER_Q17, szNine, sizeof(szNine)); 
                              LoadString(hInst, GER_Q31, szTen, sizeof(szTen)); 
                              LoadString(hInst, GER_Q32, szEleven, sizeof(szEleven)); 
                              SetWindowText(hDlgWnd, szOne); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CLEAN), szTwo);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_STARTUP), szThree); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_SDMRM), szFour); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_UPDATE), szFive);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_OPNLG), szSix); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_JRLOG), szSeven); 
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_GO), szEight);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_DONATE), szNine);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_RMREG), szTen);
                              SetWindowText(GetDlgItem(hDlgWnd, IDB_CHKVER), szEleven);
                        break;
                  }
             }
             break; 
             
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_DONATE:
                         {
                               ShellExecute(NULL, "open", "http://raproducts.org/supportus.html", NULL, NULL, SW_SHOWNORMAL); 
                         }
                         break;
                         
                         case IDB_GO:
                         {
                             int checkBoxOne = SendMessage( GetDlgItem(hDlgWnd, IDB_CLEAN), BM_GETCHECK, 0, 0);
                             int checkBoxTwo = SendMessage( GetDlgItem(hDlgWnd, IDB_STARTUP), BM_GETCHECK, 0, 0); 
                             int checkBoxThree = SendMessage( GetDlgItem(hDlgWnd, IDB_UPDATE), BM_GETCHECK, 0, 0);
                             int checkBoxFour = SendMessage ( GetDlgItem(hDlgWnd, IDB_JRLOG), BM_GETCHECK, 0, 0);
                             int checkBoxFive = SendMessage ( GetDlgItem(hDlgWnd, IDB_SDMRM), BM_GETCHECK, 0, 0);
                             int checkBoxSix = SendMessage ( GetDlgItem(hDlgWnd, IDB_OPNLG), BM_GETCHECK, 0, 0);
                             int checkBoxSeven = SendMessage ( GetDlgItem(hDlgWnd, IDB_RMREG), BM_GETCHECK, 0, 0); 
                             int checkBoxEight = SendMessage ( GetDlgItem(hDlgWnd, IDB_CHKVER), BM_GETCHECK, 0, 0); 
                             
                             if (checkBoxOne == BST_CHECKED) 
                             {
                                 purgeFiles();
                                 SendMessage( GetDlgItem(hDlgWnd, IDB_CLEAN), BM_SETCHECK, BST_UNCHECKED, 0); 
                                 TCHAR szOne[MAX_PATH];
                                 ZeroMemory(szOne, MAX_PATH); 
       
                                 switch(globalLanguageChosen)
                                 {
                                        case GLOBAL_LANGUAGE_ENGLISH:
                                             lstrcpy(szOne, "Finished searching for useless JRE files.");
                                        break;
                                        case GLOBAL_LANGUAGE_SPANISH:
                                             lstrcpy(szOne, "Finalizada la bsqueda de archivos intiles JRE."); 
                                        break;
                                        case GLOBAL_LANGUAGE_DUTCH:
                                             lstrcpy(szOne, "Voltooid op zoek naar nutteloze JRE-bestanden.");
                                        break;
                                        case GLOBAL_LANGUAGE_ITALIAN:
                                             lstrcpy(szOne, "Finito inutile ricerca di JRE file.");
                                        default:
                                             lstrcpy(szOne, "Finished searching for useless JRE files."); 
                                        break;
                                        case GLOBAL_LANGUAGE_FINNISH:
                                             lstrcpy(szOne, "Pttynyt etsivt hydytn JRE-tiedostoja.");
                                        break;
                                        case GLOBAL_LANGUAGE_FRENCH:
                                             lstrcpy(szOne, "Terminer la recherche de fichiers inutiles JRE.");
                                        break; 
                                        case GLOBAL_LANGUAGE_SWEDISH:
                                             lstrcpy(szOne, "Klar att ska efter meningsls JRE filer.");
                                        break; 
                                        case GLOBAL_LANGUAGE_POLISH:
                                             lstrcpy(szOne, "Zakon'czono poszukiwania bezuz.yteczne JRE plikw.");
                                        break; 
                                        case GLOBAL_LANGUAGE_GERMAN:
                                             lstrcpy(szOne, "Erledigt der Suche nach nutzlos JRE-Dateien."); 
                                        break; 
                                 }
       
                                 MessageBox(0, szOne, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION); 
                             }
                         
                             
                             if (checkBoxTwo == BST_CHECKED)
                             {
                                  RemoveRegValues(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", "SunJavaUpdateSched", false);
                                  SendMessage( GetDlgItem(hDlgWnd, IDB_STARTUP), BM_SETCHECK, BST_UNCHECKED, 0); 
                                  TCHAR szOne[MAX_PATH];
                                  ZeroMemory(szOne, MAX_PATH); 
       
                                  switch(globalLanguageChosen)
                                  {
                                        case GLOBAL_LANGUAGE_ENGLISH:
                                             lstrcpy(szOne, "Finished searching for JRE startup entries.");
                                        break;
                                        case GLOBAL_LANGUAGE_SPANISH:
                                             lstrcpy(szOne, "Finalizada la bsqueda de JRE entradas de lanzamiento."); 
                                        break;
                                        case GLOBAL_LANGUAGE_DUTCH:
                                             lstrcpy(szOne, "Afgewerkt zoeken naar JRE opstart-items.");
                                        break;
                                        case GLOBAL_LANGUAGE_ITALIAN:
                                             lstrcpy(szOne, "Finito di JRE ricerca di voci di avvio."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_FINNISH:
                                             lstrcpy(szOne, "Pttynyt etsivt JRE startup entries.");
                                        break;
                                        case GLOBAL_LANGUAGE_FRENCH: 
                                             lstrcpy(szOne, "Terminer la recherche de JRE entres de dmarrage.");
                                        break;
                                        case GLOBAL_LANGUAGE_SWEDISH:
                                             lstrcpy(szOne, "Klar att ska efter JRE start poster.");
                                        break; 
                                        case GLOBAL_LANGUAGE_POLISH:
                                             lstrcpy(szOne, "Zakon'czono poszukiwania JRE pozycje startowe."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_GERMAN:
                                             lstrcpy(szOne, "Erledigt der Suche nach JRE-Start-Eintrge."); 
                                        break;                                         
                                        default:
                                             lstrcpy(szOne, "Finished searching for JRE startup entries."); 
                                        break;
                                  }
                                  
                                  MessageBox(0, szOne, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION);
                             
                             }
                             
                             if (checkBoxThree == BST_CHECKED)
                             {
                                  SendMessage( GetDlgItem(hDlgWnd, IDB_UPDATE), BM_SETCHECK, BST_UNCHECKED, 0); 
                                  ShellExecute(NULL, "open", "http://raproducts.org/click/click.php?id=1", NULL, NULL, SW_SHOWNORMAL); 
                             }
                             
                             if (checkBoxFour == BST_CHECKED)
                             {
                                  char envVar[255];
                                  GetEnvironmentVariable("HOMEDRIVE", envVar, 255);
                                  strcat(envVar, "\\JavaRa.log");
                                  DeleteFile(envVar); 
                                  SendMessage( GetDlgItem(hDlgWnd, IDB_JRLOG), BM_SETCHECK, BST_UNCHECKED, 0); 
                                  
                                  TCHAR szOne[MAX_PATH];
                                  ZeroMemory(szOne, MAX_PATH); 
       
                                  switch(globalLanguageChosen)
                                  {
                                        case GLOBAL_LANGUAGE_ENGLISH:
                                             lstrcpy(szOne, "Finished removing the JavaRa logfile.");
                                        break;
                                        case GLOBAL_LANGUAGE_SPANISH:
                                             lstrcpy(szOne, "Finalizar la eliminacin de la JavaRa logfile."); 
                                        break;
                                        case GLOBAL_LANGUAGE_DUTCH:
                                             lstrcpy(szOne, "Voltooid het verwijderen van de JavaRa logfile.");
                                        break;
                                        case GLOBAL_LANGUAGE_ITALIAN:
                                             lstrcpy(szOne, "Finito di rimuovere la JavaRa file di log."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_FINNISH: 
                                             lstrcpy(szOne, "Pttynyt poistamalla JavaRa logfile."); 
                                        break;
                                        case GLOBAL_LANGUAGE_FRENCH: 
                                             lstrcpy(szOne, "Termin liminer les JavaRa fichier journal.");
                                        break;
                                        case GLOBAL_LANGUAGE_SWEDISH:
                                             lstrcpy(szOne, "Klar att ta bort JavaRa loggfil."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_POLISH: 
                                             lstrcpy(szOne, "Zakon'czono usunie;cie JavaRa logfile."); 
                                        break; 
                                        case GLOBAL_LANGUAGE_GERMAN: 
                                             lstrcpy(szOne, "Fertig Entfernen der JavaRa Logfile.");
                                        break; 
                                        default:
                                             lstrcpy(szOne, "Finished removing the JavaRa logfile."); 
                                        break;
                                  }
                                  
                                  MessageBox(0, szOne, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION);
                             }
                             
                             if (checkBoxFive == BST_CHECKED)
                             {
                                  TCHAR szOne[MAX_PATH];
                                  ZeroMemory(szOne, MAX_PATH); 
                                  
                                  switch(globalLanguageChosen)
                                  {
                                         case GLOBAL_LANGUAGE_ENGLISH:
                                              LoadString(hInst, ENG_Q3, szOne, sizeof(szOne)); 
                                         break; 
                                         
                                         case GLOBAL_LANGUAGE_DUTCH:
                                              LoadString(hInst, DUT_Q3, szOne, sizeof(szOne));
                                         break;
                                         
                                         case GLOBAL_LANGUAGE_SPANISH:
                                              LoadString(hInst, ESP_Q3, szOne, sizeof(szOne));
                                         break;
                                         
                                         case GLOBAL_LANGUAGE_ITALIAN:
                                              LoadString(hInst, ITA_Q3, szOne, sizeof(szOne)); 
                                         break; 
                                         
                                         case GLOBAL_LANGUAGE_SWEDISH:
                                              LoadString(hInst, SVE_Q3, szOne, sizeof(szOne));
                                         break;
                                         
                                         case GLOBAL_LANGUAGE_FRENCH:
                                              LoadString(hInst, FRA_Q3, szOne, sizeof(szOne)); 
                                         break;
                                         
                                         case GLOBAL_LANGUAGE_FINNISH:
                                              LoadString(hInst, FIN_Q3, szOne, sizeof(szOne));
                                         break; 
                                         
                                         case GLOBAL_LANGUAGE_POLISH: 
                                              LoadString(hInst, POL_Q3, szOne, sizeof(szOne)); 
                                         break;
                                         
                                         case GLOBAL_LANGUAGE_GERMAN: 
                                              LoadString(hInst, GER_Q3, szOne, sizeof(szOne)); 
                                         break; 
                                         
                                         default: 
                                              LoadString(hInst, ENG_Q3, szOne, sizeof(szOne));
                                         break; 
                                  }
                                  
                                  if ( MessageBox(0, szOne, "JavaRa 1.15", MB_YESNO | MB_ICONQUESTION) == IDYES)
                                  {
                                       removeSDM(); 
                                       TCHAR szOne[MAX_PATH];
                                       ZeroMemory(szOne, MAX_PATH); 
       
                                       switch(globalLanguageChosen)
                                       {
                                        case GLOBAL_LANGUAGE_ENGLISH:
                                             lstrcpy(szOne, "Finished searching for and removing the Sun Download Manager.");
                                        break;
                                        case GLOBAL_LANGUAGE_SPANISH:
                                             lstrcpy(szOne, "Finalizada la bsqueda y eliminacin de la transferencia directa del Sol."); 
                                        break;
                                        case GLOBAL_LANGUAGE_DUTCH:
                                             lstrcpy(szOne, "Gereed voor het zoeken en verwijderen van de Sun Download Manager.");
                                        break;
                                        case GLOBAL_LANGUAGE_ITALIAN:
                                             lstrcpy(szOne, "Finito per la ricerca e la rimozione della Sun Download Manager.");
                                        break; 
                                        case GLOBAL_LANGUAGE_FINNISH: 
                                             lstrcpy(szOne, "Pttynyt etsi ja poistaa Sun Download Manager.");
                                        break;
                                        case GLOBAL_LANGUAGE_FRENCH: 
                                             lstrcpy(szOne, "Termin pour la recherche et de supprimer la gestionnaire de tlchargement de Sun.");
                                        break; 
                                        case GLOBAL_LANGUAGE_SWEDISH: 
                                             lstrcpy(szOne, "Klar att ska efter och ta bort Sun Download Manager.");
                                        break; 
                                        case GLOBAL_LANGUAGE_POLISH: 
                                             lstrcpy(szOne, "Zakon'czono poszukiwania i usuwania Sun Download Manager.");
                                        break; 
                                        case GLOBAL_LANGUAGE_GERMAN:
                                             lstrcpy(szOne, "Fertig fr die Suche und das Entfernen der Sun Download-Manager."); 
                                        break; 
                                        default:
                                             lstrcpy(szOne, "Finished searching for and removing the Sun Download Manager."); 
                                        break;
                                       }
                                       
                                       MessageBox(0, szOne, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION);
                                  }
                                  SendMessage( GetDlgItem(hDlgWnd, IDB_SDMRM), BM_SETCHECK, BST_UNCHECKED, 0); 
                             }
                         
                             if (checkBoxSix == BST_CHECKED)
                             {
                                   char envVar[255];
                                   GetEnvironmentVariable("HOMEDRIVE", envVar, 255);
                                   strcat(envVar, "\\JavaRa.log");
                                   ShellExecute(NULL, "open", envVar, NULL, NULL, SW_SHOWNORMAL); 
                                   SendMessage( GetDlgItem(hDlgWnd, IDB_OPNLG), BM_SETCHECK, BST_UNCHECKED, 0); 
                             }
                             
                             if (checkBoxSeven == BST_CHECKED)
                             {
                                    RemoveRegKeys(HKEY_LOCAL_MACHINE, "SOFTWARE\\JavaRa", false);
                             }
                             
                             if ( checkBoxEight == BST_CHECKED ) { 
                                   SendMessage( GetDlgItem(hDlgWnd, IDB_CHKVER), BM_SETCHECK, BST_UNCHECKED, 0); 
                                   
                                   char buffer[MAX_PATH];
                                   char temp[MAX_PATH];
                                   char javaEnvironmentVariable[MAX_PATH];
                                   char fileToRemember[MAX_PATH];
                                   char lpszFilePath[MAX_PATH]; 
                                   
                                   ZeroMemory(fileToRemember, MAX_PATH); 
                                   ZeroMemory(javaEnvironmentVariable, MAX_PATH); 
                                   ZeroMemory(temp, MAX_PATH); 
                                   ZeroMemory(buffer, MAX_PATH); 
                                                    
                                   char javaPathRemember[MAX_PATH];
                                                   
                                   GetEnvironmentVariable("PROGRAMFILES", javaEnvironmentVariable, MAX_PATH);
                                   GetEnvironmentVariable("PROGRAMFILES", javaPathRemember, MAX_PATH);
                           
                                   lstrcat(javaEnvironmentVariable, "\\Java\\j*re*");
                                   lstrcat(javaPathRemember, "\\Java\\");
                                  
                                   WIN32_FIND_DATA FindFileData;
                          
                                   HANDLE hHandle = FindFirstFile(javaEnvironmentVariable, &FindFileData); 
                                   lstrcpy(fileToRemember, FindFileData.cFileName);
                                   
                                   // fix
                                   if ( strcmp(FindFileData.cFileName, "") == 0 ) { 
                                      break;
                                   }
                                   
                                   lstrcpy(lpszFilePath, javaPathRemember); 
                                   lstrcat(lpszFilePath, FindFileData.cFileName); 
                                   lstrcat(lpszFilePath, "\\bin\\java.exe"); 
                                  
                                   while (FindNextFile(hHandle, &FindFileData) != 0) {
                                         int check = 0; 
                                
                                         for ( int i = 0; i < 12; i++ ) {
                                             check = strncmp(fileToRemember, FindFileData.cFileName, i);
                                             if ( check > 0 )
                                                  check = STR_HIGHER;
                                             else if ( check < 0 )
                                                  check = STR_LOWER; 
                                             else if ( check == 0 ) 
                                                  check = STR_EQUAL; 
                                       
                                             switch(check) {
                                                  case STR_HIGHER: 
                                                  case STR_LOWER: 
                                                  case STR_EQUAL: 
                                                      lstrcpy(lpszFilePath, javaPathRemember); 
                                                      lstrcat(lpszFilePath, FindFileData.cFileName); 
                                                      lstrcat(lpszFilePath, "\\bin\\java.exe"); 
                                                  break; 
                                            }
                                       }
                                }                     
                          
                                FindClose(hHandle); 
                                ZeroMemory(fileToRemember, MAX_PATH); 
                                
                                DWORD dwDummy;
                                DWORD dwFVISize = GetFileVersionInfoSize( lpszFilePath , &dwDummy );
                                LPBYTE lpVersionInfo = new BYTE[dwFVISize];
                                GetFileVersionInfo( lpszFilePath , 0 , dwFVISize , lpVersionInfo );
                                UINT uLen;
                                VS_FIXEDFILEINFO *lpFfi;
                                VerQueryValue( lpVersionInfo , _T("\\") , (LPVOID *)&lpFfi , &uLen );
                                DWORD dwFileVersionMS = lpFfi->dwFileVersionMS;
                                DWORD dwFileVersionLS = lpFfi->dwFileVersionLS;
                                delete [] lpVersionInfo;
                                
                                DWORD dwLeftMost = HIWORD(dwFileVersionMS);
                                DWORD dwSecondLeft = LOWORD(dwFileVersionMS);
                                DWORD dwSecondRight = HIWORD(dwFileVersionLS);
                                DWORD dwRightMost = LOWORD(dwFileVersionLS);
                                
                                sprintf(buffer, "Java JRE version: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                
                                switch ( globalLanguageChosen ) { 
                                       case GLOBAL_LANGUAGE_DUTCH: 
                                            sprintf(buffer, "Java JRE-versie: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break; 
                                       case GLOBAL_LANGUAGE_SPANISH: 
                                            sprintf(buffer, "Java JRE versin: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_ITALIAN: 
                                            sprintf(buffer, "Java JRE versione: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_SWEDISH: 
                                            sprintf(buffer, "Java JRE-version: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_FRENCH: 
                                            sprintf(buffer, "Java JRE version: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_FINNISH: 
                                            sprintf(buffer, "Java JRE versio: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_POLISH: 
                                            sprintf(buffer, "Java JRE wersji: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                       case GLOBAL_LANGUAGE_GERMAN: 
                                            sprintf(buffer, "Java JRE-Version: %d.%d.%d.%d\n" , dwLeftMost, dwSecondLeft, dwSecondRight, dwRightMost );
                                       break;
                                }
                                MessageBox(0, buffer, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION);  
                             }
                         
                         }
                         break; 
                         
                  }
                  break;
             }
             break;
       }
       return FALSE; 
}


BOOL CALLBACK InitProc( HWND hDlgWnd, UINT Message, WPARAM wParam, LPARAM lParam )
{
      HMENU hMenu = GetSystemMenu(hDlgWnd, FALSE);
    
      RemoveMenu(hMenu, SC_RESTORE, MF_BYCOMMAND);
      RemoveMenu(hMenu, SC_SIZE, MF_BYCOMMAND);
      RemoveMenu(hMenu, SC_MAXIMIZE, MF_BYCOMMAND);
    
      switch(Message)
      {
        case WM_INITDIALOG:
        {
            
            g_hbmBall = LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(IDB_IMAGE));
            DWORD dwStyle = GetWindowLong(hDlgWnd, GWL_STYLE);
            SetWindowLong(hDlgWnd, GWL_STYLE, dwStyle | SS_NOTIFY);
            
            RECT DesktopRect;
            RECT DialogRect;
            GetWindowRect(GetDesktopWindow(), &DesktopRect);
            GetWindowRect(hDlgWnd, &DialogRect);
            SetWindowPos(hDlgWnd, HWND_TOP, (DesktopRect.right - DialogRect.right) / 2, (DesktopRect.bottom - DialogRect.bottom) / 2, 0, 0, SWP_NOSIZE );
            
            SendMessage(hDlgWnd, WM_SETICON, ICON_SMALL, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));
            SendMessage(hDlgWnd, WM_SETICON, ICON_BIG, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));
            
            TCHAR szOne[MAX_PATH];
            TCHAR szTwo[MAX_PATH];
            TCHAR szThree[MAX_PATH];
            TCHAR szFour[MAX_PATH];
            TCHAR szFive[MAX_PATH];
            
            switch(globalLanguageChosen)
            {
                  case GLOBAL_LANGUAGE_DUTCH:
                       LoadString(hInst, DUT_Q4, szOne, sizeof(szOne)); 
                       LoadString(hInst, DUT_Q5, szTwo, sizeof(szTwo));
                       LoadString(hInst, DUT_Q6, szThree, sizeof(szThree)); 
                       LoadString(hInst, DUT_Q7, szFour, sizeof(szFour)); 
                       LoadString(hInst, DUT_Q8, szFive, sizeof(szFive)); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_MAINTITLE), szOne);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_SEARCH), szTwo);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_REMOVE), szThree); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_OPTIONS), szFour);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT), szFive); 
                  break;
                  
                  case GLOBAL_LANGUAGE_SPANISH:
                       LoadString(hInst, ESP_Q4, szOne, sizeof(szOne)); 
                       LoadString(hInst, ESP_Q5, szTwo, sizeof(szTwo));
                       LoadString(hInst, ESP_Q6, szThree, sizeof(szThree)); 
                       LoadString(hInst, ESP_Q7, szFour, sizeof(szFour)); 
                       LoadString(hInst, ESP_Q8, szFive, sizeof(szFive)); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_MAINTITLE), szOne);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_SEARCH), szTwo);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_REMOVE), szThree); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_OPTIONS), szFour);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT), szFive); 
                  break;
                  
                  case GLOBAL_LANGUAGE_ITALIAN:
                       LoadString(hInst, ITA_Q4, szOne, sizeof(szOne)); 
                       LoadString(hInst, ITA_Q5, szTwo, sizeof(szTwo));
                       LoadString(hInst, ITA_Q6, szThree, sizeof(szThree)); 
                       LoadString(hInst, ITA_Q7, szFour, sizeof(szFour)); 
                       LoadString(hInst, ITA_Q8, szFive, sizeof(szFive)); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_MAINTITLE), szOne);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_SEARCH), szTwo);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_REMOVE), szThree); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_OPTIONS), szFour);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT), szFive); 
                  break;
                  
                  case GLOBAL_LANGUAGE_SWEDISH:
                       LoadString(hInst, SVE_Q4, szOne, sizeof(szOne)); 
                       LoadString(hInst, SVE_Q5, szTwo, sizeof(szTwo));
                       LoadString(hInst, SVE_Q6, szThree, sizeof(szThree)); 
                       LoadString(hInst, SVE_Q7, szFour, sizeof(szFour)); 
                       LoadString(hInst, SVE_Q8, szFive, sizeof(szFive)); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_MAINTITLE), szOne);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_SEARCH), szTwo);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_REMOVE), szThree); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_OPTIONS), szFour);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT), szFive); 
                  break;
                  
                  case GLOBAL_LANGUAGE_FRENCH: 
                       LoadString(hInst, FRA_Q4, szOne, sizeof(szOne)); 
                       LoadString(hInst, FRA_Q5, szTwo, sizeof(szTwo));
                       LoadString(hInst, FRA_Q6, szThree, sizeof(szThree)); 
                       LoadString(hInst, FRA_Q7, szFour, sizeof(szFour)); 
                       LoadString(hInst, FRA_Q8, szFive, sizeof(szFive)); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_MAINTITLE), szOne);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_SEARCH), szTwo);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_REMOVE), szThree); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_OPTIONS), szFour);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT), szFive); 
                  break;
                  
                  case GLOBAL_LANGUAGE_FINNISH:
                       LoadString(hInst, FIN_Q4, szOne, sizeof(szOne)); 
                       LoadString(hInst, FIN_Q5, szTwo, sizeof(szTwo));
                       LoadString(hInst, FIN_Q6, szThree, sizeof(szThree)); 
                       LoadString(hInst, FIN_Q7, szFour, sizeof(szFour)); 
                       LoadString(hInst, FIN_Q8, szFive, sizeof(szFive)); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_MAINTITLE), szOne);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_SEARCH), szTwo);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_REMOVE), szThree); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_OPTIONS), szFour);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT), szFive); 
                  break; 
                  
                  case GLOBAL_LANGUAGE_POLISH:
                       LoadString(hInst, POL_Q4, szOne, sizeof(szOne)); 
                       LoadString(hInst, POL_Q5, szTwo, sizeof(szTwo));
                       LoadString(hInst, POL_Q6, szThree, sizeof(szThree)); 
                       LoadString(hInst, POL_Q7, szFour, sizeof(szFour)); 
                       LoadString(hInst, POL_Q8, szFive, sizeof(szFive)); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_MAINTITLE), szOne);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_SEARCH), szTwo);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_REMOVE), szThree); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_OPTIONS), szFour);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT), szFive); 
                  break; 
                  
                  case GLOBAL_LANGUAGE_GERMAN:
                       LoadString(hInst, GER_Q4, szOne, sizeof(szOne)); 
                       LoadString(hInst, GER_Q5, szTwo, sizeof(szTwo));
                       LoadString(hInst, GER_Q6, szThree, sizeof(szThree)); 
                       LoadString(hInst, GER_Q7, szFour, sizeof(szFour)); 
                       LoadString(hInst, GER_Q8, szFive, sizeof(szFive)); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_MAINTITLE), szOne);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_SEARCH), szTwo);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_REMOVE), szThree); 
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_OPTIONS), szFour);
                       SetWindowText(GetDlgItem(hDlgWnd, IDB_ABOUT), szFive); 
                  break; 
            }
            
            return TRUE;
        }
        break;
        
        case WM_PAINT:
        {
             PAINTSTRUCT ps;
             BITMAP bm;
             
             HDC hdc = BeginPaint(hDlgWnd, &ps);
             HBITMAP foo = LoadBitmap (hInst, MAKEINTRESOURCE(IDB_IMAGE));
             HDC memDC = CreateCompatibleDC (hdc);

             int save = SaveDC (memDC);

             SelectObject (memDC, foo);

             BitBlt (hdc, 12, 12, 32, 32, memDC, 0, 0, SRCCOPY);

             RestoreDC (memDC, save);
             EndPaint(hDlgWnd, &ps);
             DeleteObject (foo);
        }
        break;
        
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case IDB_ABOUT:
                {
                     DialogBox(hInst, "ABOUT_DIALOG", hDlgWnd, AboutDlgProc); 
                }
                break;
                
                case IDB_SEARCH:
                {
                     DialogBox(hInst, "UPDATE_DIALOG", hDlgWnd, UpdateDlgProc);
                }
                break;
                
                case IDB_OPTIONS:
                {
                     DialogBox(hInst, "OPTIONS_DIALOG", hDlgWnd, OptionsDlgProc);
                }
                break;
                
                case IDB_REMOVE:
                {
                     TCHAR szOne[MAX_PATH * 2];
                     TCHAR szTwo[MAX_PATH * 2];
                     
                     ZeroMemory(szOne, MAX_PATH);
                     ZeroMemory(szTwo, MAX_PATH); 
                     
                     switch(globalLanguageChosen)
                     {
                            case GLOBAL_LANGUAGE_DUTCH:
                                 LoadString(hInst, DUT_Q1, szOne, sizeof(szOne)); 
                                 LoadString(hInst, DUT_Q2, szTwo, sizeof(szTwo));
                            break; 
                            case GLOBAL_LANGUAGE_SPANISH: 
                                 LoadString(hInst, ESP_Q1, szOne, sizeof(szOne));
                                 LoadString(hInst, ESP_Q2, szTwo, sizeof(szTwo));
                            break;
                            case GLOBAL_LANGUAGE_ENGLISH:
                                 LoadString(hInst, ENG_Q1, szOne, sizeof(szOne)); 
                                 LoadString(hInst, ENG_Q2, szTwo, sizeof(szTwo)); 
                            break;
                            case GLOBAL_LANGUAGE_ITALIAN:
                                 LoadString(hInst, ITA_Q1, szOne, sizeof(szOne)); 
                                 LoadString(hInst, ITA_Q2, szTwo, sizeof(szTwo)); 
                            break; 
                            case GLOBAL_LANGUAGE_SWEDISH:
                                 LoadString(hInst, SVE_Q1, szOne, sizeof(szOne)); 
                                 LoadString(hInst, SVE_Q2, szTwo, sizeof(szTwo));
                            break; 
                            case GLOBAL_LANGUAGE_FRENCH:
                                 LoadString(hInst, FRA_Q1, szOne, sizeof(szOne)); 
                                 LoadString(hInst, FRA_Q2, szTwo, sizeof(szTwo));
                            break; 
                            case GLOBAL_LANGUAGE_FINNISH: 
                                 LoadString(hInst, FIN_Q1, szOne, sizeof(szOne)); 
                                 LoadString(hInst, FIN_Q2, szTwo, sizeof(szTwo));
                            break; 
                            case GLOBAL_LANGUAGE_POLISH: 
                                 LoadString(hInst, POL_Q1, szOne, sizeof(szOne)); 
                                 LoadString(hInst, POL_Q2, szTwo, sizeof(szTwo));
                            break; 
                            case GLOBAL_LANGUAGE_GERMAN:
                                 LoadString(hInst, GER_Q1, szOne, sizeof(szOne)); 
                                 LoadString(hInst, GER_Q2, szTwo, sizeof(szTwo)); 
                            break; 
                            
                     }     
                     
                     if ( MessageBox(0, szOne, "JavaRa 1.15", MB_YESNO | MB_ICONQUESTION) == IDYES )
                     {
                          RunJRERemove(false); 
                          MessageBox(0, szTwo, "JavaRa 1.15", MB_OK | MB_ICONINFORMATION);
                          
                          char envVar[255];
                          GetEnvironmentVariable("HOMEDRIVE", envVar, 255);
                          strcat(envVar, "\\JavaRa.log");
                          ShellExecute(NULL, "open", envVar, NULL, NULL, SW_SHOWNORMAL);  
                     }
                     
                }
                break;
                           
            }
        break;
        
        case WM_CLOSE:
             EndDialog(hDlgWnd, 0);
             DestroyWindow(hDlgWnd);
        break;
        
        case WM_DESTROY:
             EndDialog (hDlgWnd, 0);
             PostQuitMessage(0);
        break;
    }
    return FALSE;
}

BOOL CALLBACK LangDlgProc (HWND hDlgWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam)
{
       switch (message)
       {
       
             case WM_DESTROY:
		   	       EndDialog(hDlgWnd, 0);
		   	       PostQuitMessage(0);
             return TRUE;
	   
	         case WM_CLOSE:
                  EndDialog(hDlgWnd, 0);
                  DestroyWindow(hDlgWnd); 
             break;
             
             case WM_INITDIALOG:
             {
                  RECT DesktopRect;
                  RECT DialogRect;
                  GetWindowRect(GetDesktopWindow(), &DesktopRect);
                  GetWindowRect(hDlgWnd, &DialogRect);
                  SetWindowPos(hDlgWnd, HWND_TOP, (DesktopRect.right - DialogRect.right) / 2, (DesktopRect.bottom - DialogRect.bottom) / 2, 0, 0, SWP_NOSIZE );
            
                  
                  SendMessage(hDlgWnd, WM_SETICON, ICON_SMALL, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));
                  SendMessage(hDlgWnd, WM_SETICON, ICON_BIG, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));
                  
                  for (int i = 0; i <= 8; i++)
                  {
                      SendDlgItemMessage(hDlgWnd, IDB_LANGCBO, CB_ADDSTRING, 0, (LPARAM)langList[i]);
                  }
                  
                  DWORD dwSize = 0; 
                  DWORD dwType = REG_SZ; 
                  
                  HKEY hKey;
                  if ( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\JavaRa", 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS )
                  {
                       
                       if ( RegQueryValueEx(hKey, "JavaRa", NULL, NULL, NULL, &dwSize) == ERROR_SUCCESS )
                       {
                           RegQueryValueEx(hKey, "JavaRa", NULL, NULL, (LPBYTE)NULL, &dwSize); 
                           TCHAR * regSelection = new TCHAR[dwSize / sizeof(TCHAR)];
                           RegQueryValueEx(hKey, "JavaRa", NULL, NULL, (LPBYTE)regSelection, &dwSize); 
                           
                           HWND hWnd;
                           
                           // char * langList[] = { "English", "Nederlands", "Espaol", "Italiano", "Svenska", "Franais", "Suomi", "Polski", "Deutsch" } ;
                           
                           for ( int i = 0; i < 9; i++ ) { 
                               if ( lstrcmp(regSelection, langList[i]) == 0 ) { 
                                    switch(i) { 
                                              case 0: 
                                                   globalLanguageChosen = GLOBAL_LANGUAGE_ENGLISH;
                                              break;
                                              
                                              case 1: 
                                                   globalLanguageChosen = GLOBAL_LANGUAGE_DUTCH;
                                              break;
                                              
                                              case 2: 
                                                   globalLanguageChosen = GLOBAL_LANGUAGE_SPANISH;
                                              break; 
                                              
                                              case 3: 
                                                   globalLanguageChosen = GLOBAL_LANGUAGE_ITALIAN;
                                              break;
                                              
                                              case 4: 
                                                   globalLanguageChosen = GLOBAL_LANGUAGE_SWEDISH;
                                              break;
                                              
                                              case 5: 
                                                   globalLanguageChosen = GLOBAL_LANGUAGE_FRENCH;
                                              break;
                                              
                                              case 6: 
                                                   globalLanguageChosen = GLOBAL_LANGUAGE_FINNISH;
                                              break;
                                              
                                              case 7: 
                                                    globalLanguageChosen = GLOBAL_LANGUAGE_POLISH;
                                              break;
                                              
                                              case 8: 
                                                   globalLanguageChosen = GLOBAL_LANGUAGE_GERMAN;
                                              break;
                                    }
                               }
                           }
                           
                          
                           EndDialog(hDlgWnd, 0);
                           hWnd = CreateDialog( hInst, (LPCTSTR)"DIALOG_NAME", NULL, (DLGPROC)InitProc );
                           
                           RegCloseKey(hKey); 
                           delete [] regSelection; 
                       }
                  }
                            
             }
             break; 
             
             
             case WM_COMMAND:
             {
                  switch (LOWORD (wParam))
                  {
                         case IDB_IGO:
                         {
                              int getSelected = SendMessage(GetDlgItem(hDlgWnd, IDB_LANGCBO), CB_GETCURSEL, 0, 0);
                              globalLanguageChosen = getSelected;
                              
                              if (getSelected == CB_ERR)
                              {
                                  MessageBox(0, "Please select a language.", "JavaRa 1.15", MB_OK | MB_ICONINFORMATION);
                                  break; 
                              }
                              
                              int checkBoxOne = SendMessage( GetDlgItem(hDlgWnd, IDB_LANGCHK), BM_GETCHECK, 0, 0); 
                              if (checkBoxOne == BST_CHECKED)
                              {
                                    int regCheck; 
                                    HKEY hKey;
                                    regCheck = RegCreateKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\JavaRa", &hKey);
                                    
                                    if (regCheck == 0)
                                    {
                                        char gottenListboxText[MAX_PATH];
                                        ZeroMemory(gottenListboxText, MAX_PATH); 
                                        SendMessage(GetDlgItem(hDlgWnd, IDB_LANGCBO), CB_GETLBTEXT, getSelected, (LPARAM)gottenListboxText); 
                                        RegSetValueEx( (HKEY) hKey, "JavaRa", 0, REG_SZ, (BYTE *)gottenListboxText, strlen(gottenListboxText) );
                                        RegCloseKey(hKey); 
                                    }
                                    
                                    else if ( regCheck != 0 ) { 
                                         MessageBox(0, "Unable to create registry key!", "JavaRa 1.15", MB_OK | MB_ICONINFORMATION); 
                                    }
                              }
                              
                              EndDialog(hDlgWnd, 0);
                              HWND hWnd = CreateDialog( hInst, (LPCTSTR)"DIALOG_NAME", NULL, (DLGPROC)InitProc );
                              
                         }
                         break; 
                  }
                  break;
             }
             break;
        }
        
        
        return FALSE;
}

VOID Thread(PVOID pvoid) { 
     RunJRERemove(true);
}

HANDLE OneInstance( LPCTSTR lpName )
{
	HANDLE hMutex = CreateMutex(NULL, TRUE, lpName);

	switch(GetLastError())
	{
		case ERROR_SUCCESS:
			break;

		case ERROR_ALREADY_EXISTS:
			hMutex = NULL;
			MessageBox(0, "This program is already running!", "JavaRa 1.15", MB_OK | MB_ICONERROR);
			break;

		default:
			hMutex = NULL;
			break;
	}
	return hMutex;
}

INT WINAPI WinMain( HINSTANCE  hInstance,
                    HINSTANCE  hPrevInstance,
                    LPSTR      lpCmdLine,
                    INT        nCmdShow )
{
    HANDLE hMutex = OneInstance("JavaRa");
    
    if(!hMutex)
    {
		return FALSE;
    }
    
    char * commandList[] = { "-runsilent", "--runsilent", "--purgefiles", "-p", "-r", "--removeSDM" } ;

    if ( strcmp(lpCmdLine, "") != 0 ) {
         
         char * str = strtok(lpCmdLine, " "); 
         while ( str != NULL ) { 
            for ( int i = 0; i < 6; i++ ) {
                  
                   if ( strcmp(commandList[i], str) == 0 ) {
                      switch(i) {
                                case 0: 
                                case 1:
                                case 4: 
                                     _beginthread(Thread, 0, NULL); 
                                break; 
            
                                case 2:
                                case 3: 
                                     purgeFiles(); 
                                break; 
                                
                                case 5:
                                     removeSDM(); 
                                break; 
                     }
                  }
               } 
               
               str = strtok(NULL, " ");   
                          
         }
         
         return 0;
    }
    
    hInst = hInstance;

    HWND hWnd = CreateDialog( hInstance, (LPCTSTR)"LANG_DIALOG", NULL, (DLGPROC)LangDlgProc );
                              
    HMENU hMenu = GetSystemMenu(hWnd, FALSE);
    
    RemoveMenu(hMenu, SC_RESTORE, MF_BYCOMMAND);
    RemoveMenu(hMenu, SC_SIZE, MF_BYCOMMAND);
    RemoveMenu(hMenu, SC_MAXIMIZE, MF_BYCOMMAND);
    
    MSG    Msg;

    while(GetMessage(&Msg, NULL,0,0) == TRUE)
    {
        if(!IsDialogMessage(hWnd,&Msg))
        {
            TranslateMessage(&Msg);
            DispatchMessage(&Msg);
        }
    }
    return Msg.wParam;
}
